Package: rdocdump
Title: Dump 'R' Package Source, Documentation, and Vignettes into One
        File
Version: 0.3.0
Authors@R: 
    person("Egor", "Kotov", , "kotov.egor@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-6690-5345"))
Description: Dump source code, documentation and vignettes of an 'R'
    package into a single file. Supports installed packages, tar.gz
    archives, and package source directories. If the package is not
    installed, only its source is automatically downloaded from CRAN for
    processing. The output is a single plain text file or a character
    vector, which is useful to ingest complete package documentation and
    source into a large language model (LLM) or pass it further to other
    tools, such as 'ragnar' <https://github.com/tidyverse/ragnar> to
    create a Retrieval-Augmented Generation (RAG) workflow.
License: MIT + file LICENSE
URL: https://github.com/e-kotov/rdocdump,
        https://www.ekotov.pro/rdocdump/
BugReports: https://github.com/e-kotov/rdocdump/issues
Suggests: curl, pak, quarto, testthat (>= 3.0.0), withr
VignetteBuilder: quarto
Config/testthat/edition: 3
Encoding: UTF-8
Language: en
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-05-30 16:57:41 UTC; ek
Author: Egor Kotov [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-6690-5345>)
Maintainer: Egor Kotov <kotov.egor@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-30 17:10:02 UTC
Built: R 4.5.2; ; 2026-05-30 17:20:07 UTC; unix

Package: rdocdump
Title: Dump 'R' Package Source, Documentation, and Vignettes into One
        File
Version: 0.3.0
Authors@R: 
    person("Egor", "Kotov", , "kotov.egor@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-6690-5345"))
Description: Dump source code, documentation and vignettes of an 'R'
    package into a single file. Supports installed packages, tar.gz
    archives, and package source directories. If the package is not
    installed, only its source is automatically downloaded from CRAN for
    processing. The output is a single plain text file or a character
    vector, which is useful to ingest complete package documentation and
    source into a large language model (LLM) or pass it further to other
    tools, such as 'ragnar' <https://github.com/tidyverse/ragnar> to
    create a Retrieval-Augmented Generation (RAG) workflow.
License: MIT + file LICENSE
URL: https://github.com/e-kotov/rdocdump,
        https://www.ekotov.pro/rdocdump/
BugReports: https://github.com/e-kotov/rdocdump/issues
Suggests: curl, pak, quarto, testthat (>= 3.0.0), withr
VignetteBuilder: quarto
Config/testthat/edition: 3
Encoding: UTF-8
Language: en
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-05-30 16:57:41 UTC; ek
Author: Egor Kotov [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-6690-5345>)
Maintainer: Egor Kotov <kotov.egor@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-30 17:10:02 UTC
Built: R 4.6.0; ; 2026-05-30 18:00:30 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# rdocdump: Dump ‘R’ Package Source, Documentation, and Vignettes into One File <a href="https://www.ekotov.pro/rdocdump/"><img src="man/figures/logo.png" align="right" width="200" alt="rdocdump website" /></a>

<!-- badges: start -->

[![Project Status:
Active](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![CRAN
status](https://www.r-pkg.org/badges/version/rdocdump)](https://CRAN.R-project.org/package=rdocdump)
<a href="https://CRAN.R-project.org/package=rdocdump"
target="_blank"><img
src="https://cranlogs.r-pkg.org/badges/grand-total/rdocdump?color=blue"
alt="CRAN/METACRAN Total downloads" /></a>
<a href="https://CRAN.R-project.org/package=rdocdump"
target="_blank"><img
src="https://cranlogs.r-pkg.org/badges/rdocdump?color=blue"
alt="CRAN/METACRAN Downloads per month" /></a>
[![R-CMD-check](https://github.com/e-kotov/rdocdump/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/e-kotov/rdocdump/actions/workflows/R-CMD-check.yaml)
[![pkgcheck](https://github.com/e-kotov/rdocdump/workflows/pkgcheck/badge.svg)](https://github.com/e-kotov/rdocdump/actions?query=workflow%3Apkgcheck)

[![DOI](https://zenodo.org/badge/DOI/10.32614/CRAN.package.rdocdump.svg)](https://doi.org/10.32614/CRAN.package.rdocdump)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.15072446.svg)](https://doi.org/10.5281/zenodo.15072446)
<!-- badges: end -->

Dump source code, documentation and vignettes of an `R` package into a
single file. Supports installed packages, `tar.gz` archives, and package
source directories. If the package is not installed, only its source is
automatically downloaded from CRAN for processing. The output is a
single plain text file or a `character` vector, which is useful to
ingest complete package documentation and source into a large language
model (LLM) or pass it further to other tools, such as
<a href="https://github.com/tidyverse/ragnar"
target="_blank"><code>{ragnar}</code></a> to create a
Retrieval-Augmented Generation (RAG) workflow.

## Installation

Install the latest stable release of `rdocdump` from CRAN with:

``` r
install.packages("rdocdump")
```

You can install the development version of `rdocdump` from R Universe
with:

``` r
install.packages('rdocdump',
 repos = c('https://e-kotov.r-universe.dev', 'https://cloud.r-project.org')
)
```

or from GitHub with:

``` r
# install.packages("pak")
pak::pak("e-kotov/rdocdump")
```

## Example

Extract documenation and source code of `{rJavaEnv}` package by
downloading source from CRAN and save it to file `rJavaEnv_docs.txt`

``` r
rdd_to_txt(
  pkg = "rJavaEnv",
  file = tempfile("rJavaEnv_docs_", fileext = ".txt"),
  force_fetch = TRUE, # force download even if package is installed
  keep_files = "none" # delete temp files
)
```

## Citation

To cite package ‘rdocdump’ in publications use:

Kotov E (2025). *rdocdump: Dump R Package Source, Documentation, and
Vignettes into One File*. doi:10.32614/CRAN.package.rdocdump
<https://doi.org/10.32614/CRAN.package.rdocdump>.
<https://github.com/e-kotov/rdocdump>.

BibTeX:

    @Manual{rdocdump,
      title = {rdocdump: Dump R Package Source, Documentation, and Vignettes into One File},
      author = {Egor Kotov},
      year = {2025},
      url = {https://github.com/e-kotov/rdocdump},
      doi = {10.32614/CRAN.package.rdocdump},
    }

.onLoad <- function(libname, pkgname) {
  default_cache <- file.path(tempdir(), "rdocdump_cache")
  if (is.null(getOption("rdocdump.cache_path"))) {
    options(rdocdump.cache_path = default_cache)
  }
  # Set default repository option for rdocdump
  if (is.null(getOption("rdocdump.repos"))) {
    options(rdocdump.repos = c("CRAN" = "https://cloud.r-project.org"))
  }
}

# test_that(".onLoad sets rdocdump.cache_path if not already set", {
#   # Backup any existing option
#   old_opt <- getOption("rdocdump.cache_path")
#   options(rdocdump.cache_path = NULL)

#   # Expected default value based on tempdir()
#   default_cache <- file.path(tempdir(), "rdocdump_cache")

#   # Call .onLoad
#   .onLoad(libname = NULL, pkgname = NULL)
#   expect_equal(getOption("rdocdump.cache_path"), default_cache)

#   # Restore previous option
#   options(rdocdump.cache_path = old_opt)
# })

# test_that(".onLoad does not override existing rdocdump.cache_path", {
#   old_value <- file.path(tempdir(), "existing_cache")
#   options(rdocdump.cache_path = old_value)

#   .onLoad(libname = NULL, pkgname = NULL)
#   expect_equal(getOption("rdocdump.cache_path"), old_value)
# })

#' Dump Package Source, Documentationm and Vignettes into Plain Text
#'
#' @description
#' This function produces a single text output for an R package by processing its documentation (Rd files from the package source or the documentation from already installed packages), vignettes, and/or R source code.
#'
#' @param pkg A `character` string specifying the package. This can be:
#' \itemize{
#'   \item an installed package name,
#'   \item a full path to a package source directory,
#'   \item a full path to a package archive file (tar.gz), or
#'   \item a package name not installed (which will then be downloaded from CRAN).
#' }
#' @param file Optional. Save path for the output text file. If set, the function will return the path to the file instead of the combined text. Defaults to `NULL`.
#' @param force_fetch `logical`. If `TRUE`, the package source will be fetched from CRAN as a tar.gz archive even if the package is already installed locally. Default is `FALSE`, but when `version` is specified, it will be set to `TRUE`.
#' @param version Optional. A `character` string specifying the package version to fetch from CRAN. If not provided, the latest version will be used.
#' @param content A character vector specifying which components to include in the output.
#' Possible values are:
#' \itemize{
#'   \item `"all"`: Include Rd documentation, vignettes, and R source code (default).
#'   \item `"docs"`: Include only the Rd documentation.
#'   \item `"vignettes"`: Include only the vignettes.
#'   \item `"code"`: Include only the R source code. When extracting code for non-installed packages, the function will not include roxygen2 documentation, as the documentation can be imported from the Rd files. If you want to extract the R source code with the roxygen2 documentation, use \code{\link{rdd_extract_code}} and set `include_roxygen` to `TRUE`.
#' }
#' You can specify multiple options (e.g., `c("docs", "code")` to include both documentation and source code).
#' @param keep_files A `character` value controlling whether temporary files should be kept.
#' Possible values are:
#' \itemize{
#'   \item `"none"`: Delete both the tar.gz archive and the extracted files (default).
#'   \item `"tgz"`: Keep only the tar.gz archive.
#'   \item `"extracted"`: Keep only the extracted files.
#'   \item `"both"`: Keep both the tar.gz archive and the extracted files.
#' }
#' @param cache_path A `character` string specifying the directory where kept temporary files will be stored.
#' By default, it uses the value of `getOption("rdocdump.cache_path")` which sets the cache directory to the temporary directory of the current R session.
#'
#' @param repos A `character` vector of repository URLs. By default, it uses the value of `getOption("rdocdump.repos")` which sets the repository URLs to the default R repositories and is itself set to `c("CRAN" = "https://cloud.r-project.org")` on package load to prevent accidental downloads of pre-built packages from Posit Package Manager and R Universe.
#'
#' @return A single string containing the combined package documentation, vignettes, and/or code as specified by the `content` argument.
#' If the `file` argument is set, returns the path to the file.
#'
#' @export
#'
#' @examples
#' # Extract documentation for built-in `stats` package (both docs and vignettes).
#' docs <- rdd_to_txt("splines")
#' cat(substr(docs, 1, 500))
#'
#' \donttest{
#' # set cache directory for `rdocdump`
#' rdd_set_cache_path(paste0(tempdir(), "/rdocdump_cache"))
#'
#' # Extract only documentation for rJavaEnv by downloading its source from CRAN
#' docs <- rdd_to_txt(
#'   "rJavaEnv",
#'   force_fetch = TRUE,
#'   content = "docs",
#'   repos = c("CRAN" = "https://cran.r-project.org")
#' )
#' lines <- unlist(strsplit(docs, "\n"))
#' # Print the first 3 lines
#' cat(head(lines, 3), sep = "\n")
#' # Print the last 3 lines
#' cat(tail(lines, 3), sep = "\n")
#'
#' # clean cache directory
#' unlink(getOption("rdocdump.cache_path"), recursive = TRUE, force = TRUE)
#' }
#'
rdd_to_txt <- function(
  pkg,
  file = NULL,
  content = "all",
  force_fetch = FALSE,
  version = NULL,
  keep_files = "none",
  cache_path = getOption("rdocdump.cache_path"),
  repos = getOption("rdocdump.repos", getOption("repos"))
) {
  # Validate keep_files argument.
  if (!keep_files %in% c("none", "tgz", "extracted", "both")) {
    stop(
      'Invalid value for keep_files. Choose one of "none", "tgz", "extracted", "both".'
    )
  }

  # Define allowed content options.
  allowed_content <- c("docs", "vignettes", "code")
  # If "all" is specified, use all allowed options.
  if ("all" %in% content) {
    effective_content <- allowed_content
  } else {
    effective_content <- content
  }
  if (!all(effective_content %in% allowed_content)) {
    stop(paste(
      'Invalid value for content. Choose any of',
      paste(c("all", allowed_content), collapse = ", "),
      "."
    ))
  }

  # Resolve package source path using the existing helper.
  pkg_info <- resolve_pkg_path(
    pkg,
    cache_path,
    force_fetch = force_fetch || !is.null(version),
    version = version,
    repos = repos
  )
  pkg_path <- pkg_info$pkg_path

  # Initialize component texts.
  docs_text <- ""
  vignettes_text <- ""
  code_text <- ""

  if ("docs" %in% effective_content) {
    docs_text <- combine_rd(
      pkg_path,
      is_installed = pkg_info$is_installed,
      pkg_name = pkg_info$pkg_name
    )
  }
  if ("vignettes" %in% effective_content) {
    vignettes_text <- combine_vignettes(pkg_path)
  }
  if ("code" %in% effective_content) {
    code_text <- rdd_extract_code(
      pkg = if (pkg_info$is_installed) pkg else pkg_path,
      file = NULL,
      include_tests = FALSE,
      include_roxygen = FALSE,
      force_fetch = force_fetch || !is.null(version),
      version = version,
      cache_path = cache_path,
      keep_files = "both" # make sure the files are not deleted prematurely, as rdd_to_txt will take care of that later
    )
  }

  # Combine components in a fixed order: docs, vignettes, then code.
  components <- list()
  if ("docs" %in% effective_content && nzchar(docs_text)) {
    components <- c(components, docs_text)
  }
  if ("vignettes" %in% effective_content && nzchar(vignettes_text)) {
    components <- c(components, vignettes_text)
  }
  if ("code" %in% effective_content && nzchar(code_text)) {
    components <- c(components, code_text)
  }
  combined_text <- paste(components, collapse = "\n\n")

  # Clean up temporary files according to keep_files
  cleanup_result <- cleanup_files(pkg_info, keep_files)

  if (!is.null(file)) {
    writeLines(combined_text, con = file)
    return(file)
  }
  return(combined_text)
}

# Tests for the rdd_to_txt function in the rdocdump package
fake_resolve_pkg_path <- function(
  pkg,
  cache_path,
  force_fetch,
  version,
  repos
) {
  list(
    pkg_path = pkg,
    is_installed = FALSE,
    pkg_name = "testpkg",
    tar_path = NULL,
    version = NULL,
    extracted_path = NULL
  )
}

test_that("rdd_to_txt works for installed packages", {
  # Use an installed package such as "stats".
  txt <- rdd_to_txt("stats", keep_files = "none")

  expect_true(nchar(txt) > 0)
  expect_match(txt, "Function:")
})

test_that("rdd_to_txt with invalid keep_files value errors", {
  expect_error(
    rdd_to_txt("stats", keep_files = "invalid"),
    "Invalid value for keep_files"
  )
})

test_that("rdd_to_txt writes output to file when file parameter is provided", {
  temp_file <- tempfile("rdoc_output", fileext = ".txt")
  on.exit(unlink(temp_file))

  txt <- rdd_to_txt("stats", file = temp_file, keep_files = "none")
  expect_true(file.exists(temp_file))
  content <- readLines(temp_file)
  expect_true(length(content) > 0)
})

test_that("rdd_to_txt combines DESCRIPTION, Rd documentation and vignettes", {
  pkg_dir <- tempfile("pkg_")
  dir.create(pkg_dir)

  # Create a minimal DESCRIPTION file so that combine_rd() works.
  desc_file <- file.path(pkg_dir, "DESCRIPTION")
  writeLines(c("Package: testpkg", "Version: 0.1"), desc_file)

  # Create a dummy 'man' directory with an Rd file (for documentation)
  man_dir <- file.path(pkg_dir, "man")
  dir.create(man_dir)
  rd_file <- file.path(man_dir, "test.Rd")
  writeLines("\\name{test}\n\\alias{test}\n\\title{Test Function}", rd_file)

  # Create a 'vignettes' directory with a sample vignette file
  vignette_dir <- file.path(pkg_dir, "vignettes")
  dir.create(vignette_dir)
  vign_file <- file.path(vignette_dir, "example.md")
  writeLines("This is a vignette", vign_file)

  local_mocked_bindings(
    resolve_pkg_path = fake_resolve_pkg_path,
    .package = "rdocdump"
  )

  out <- rdd_to_txt(pkg_dir, keep_files = "none")

  # Adjusted expectations:
  # Check that the output includes the DESCRIPTION content.
  expect_match(
    out,
    "Package: testpkg",
    info = "Output should include DESCRIPTION header with package name"
  )
  # Check that the output includes the Rd documentation header for the Rd file.
  expect_match(
    out,
    "Function: test\\(\\)",
    info = "Output should include Rd documentation header"
  )
  # Check that the output includes the vignette header.
  expect_match(
    out,
    "Vignette: example\\.md",
    info = "Output should include vignette header"
  )
  # Check that the output includes the vignette content.
  expect_match(
    out,
    "This is a vignette",
    info = "Output should include vignette content"
  )
})


test_that("rdd_to_txt outputs only documentation when content is 'docs'", {
  pkg_dir <- tempfile("pkg_")
  dir.create(pkg_dir)

  # Create a minimal DESCRIPTION file so that combine_rd() works.
  desc_file <- file.path(pkg_dir, "DESCRIPTION")
  writeLines(c("Package: testpkg", "Version: 0.1"), desc_file)

  # Create a dummy 'man' directory with an Rd file (for documentation)
  man_dir <- file.path(pkg_dir, "man")
  dir.create(man_dir)
  rd_file <- file.path(man_dir, "test.Rd")
  writeLines("\\name{test}\n\\alias{test}\n\\title{Test Function}", rd_file)

  # Create a 'vignettes' directory with a sample vignette file
  vignette_dir <- file.path(pkg_dir, "vignettes")
  dir.create(vignette_dir)
  vign_file <- file.path(vignette_dir, "example.md")
  writeLines("This is a vignette", vign_file)

  local_mocked_bindings(
    resolve_pkg_path = fake_resolve_pkg_path,
    .package = "rdocdump"
  )

  out_docs <- rdd_to_txt(pkg_dir, keep_files = "none", content = "docs")

  # Check that the output includes the DESCRIPTION and Rd documentation headers...
  expect_match(
    out_docs,
    "Package: testpkg",
    info = "Output should include DESCRIPTION header"
  )
  expect_match(
    out_docs,
    "Function: test\\(\\)",
    info = "Output should include Rd documentation header"
  )

  # ...but it should NOT include the vignette header or content.
  expect_false(
    grepl("Vignette: example\\.md", out_docs),
    info = "Output should not include vignette header"
  )
  expect_false(
    grepl("This is a vignette", out_docs),
    info = "Output should not include vignette content"
  )
})

test_that("rdd_to_txt outputs only vignettes when content is 'vignettes'", {
  pkg_dir <- tempfile("pkg_")
  dir.create(pkg_dir)

  # Create a minimal DESCRIPTION file.
  desc_file <- file.path(pkg_dir, "DESCRIPTION")
  writeLines(c("Package: testpkg", "Version: 0.1"), desc_file)

  # Create a dummy 'man' directory with an Rd file.
  man_dir <- file.path(pkg_dir, "man")
  dir.create(man_dir)
  rd_file <- file.path(man_dir, "test.Rd")
  writeLines("\\name{test}\n\\alias{test}\n\\title{Test Function}", rd_file)

  # Create a 'vignettes' directory with a sample vignette file.
  vignette_dir <- file.path(pkg_dir, "vignettes")
  dir.create(vignette_dir)
  vign_file <- file.path(vignette_dir, "example.md")
  writeLines("This is a vignette", vign_file)

  local_mocked_bindings(
    resolve_pkg_path = fake_resolve_pkg_path,
    .package = "rdocdump"
  )

  out_vignettes <- rdd_to_txt(
    pkg_dir,
    keep_files = "none",
    content = "vignettes"
  )

  # Check that the output includes the vignette header and content.
  expect_match(
    out_vignettes,
    "Vignette: example\\.md",
    info = "Output should include vignette header"
  )
  expect_match(
    out_vignettes,
    "This is a vignette",
    info = "Output should include vignette content"
  )

  # But it should NOT include the documentation header.
  expect_false(
    grepl("Function: test\\(\\)", out_vignettes),
    info = "Output should not include Rd documentation header"
  )
})

test_that("rdd_to_txt keeps tar.gz archive when keep_files is 'tgz'", {
  skip_on_cran()
  skip_if_offline()

  # Create a unique cache directory for this test.
  cache_dir <- tempfile("cache_tgz")
  dir.create(cache_dir)

  # Call rdd_to_txt on the "ini" package.
  # force_fetch = TRUE ensures it downloads from CRAN,
  # and keep_files = "tgz" should leave the tar.gz archive in the cache.
  old_repos <- getOption("repos")
  options(repos = c(CRAN = "https://cloud.r-project.org"))
  out <- suppressWarnings(rdd_to_txt(
    "ini",
    force_fetch = TRUE,
    keep_files = "tgz",
    cache_path = cache_dir
  ))
  options(repos = old_repos)

  # Look for any tar.gz file in the cache directory.
  tar_files <- list.files(
    cache_dir,
    pattern = "\\.tar\\.gz$",
    full.names = TRUE
  )
  expect_true(length(tar_files) > 0)

  # Clean up the cache directory.
  unlink(cache_dir, recursive = TRUE)
})

test_that("rdd_to_txt keeps both tar.gz archive and extracted files when keep_files is 'both'", {
  skip_on_cran()
  skip_if_offline()

  # Create a unique cache directory.
  cache_dir <- tempfile("cache_both")
  dir.create(cache_dir)

  # Call rdd_to_txt on the "ini" package with keep_files = "both".
  old_repos <- getOption("repos")
  options(repos = c(CRAN = "https://cloud.r-project.org"))
  out <- suppressWarnings(rdd_to_txt(
    "ini",
    force_fetch = TRUE,
    keep_files = "both",
    cache_path = cache_dir
  ))
  options(repos = old_repos)

  # Check that a tar.gz file exists in the cache.
  tar_files <- list.files(
    cache_dir,
    pattern = "\\.tar\\.gz$",
    full.names = TRUE
  )
  expect_true(length(tar_files) > 0)

  # For the extracted package: resolve_pkg_path creates an extraction directory
  # as file.path(cache_dir, <pkgname>, <version>). For package "ini", we expect a subdirectory
  # named "ini" to exist under cache_dir.
  extracted_dir <- file.path(cache_dir, "ini")
  expect_true(dir.exists(extracted_dir))

  # There should be at least one directory inside the "ini" folder.
  subdirs <- list.dirs(extracted_dir, recursive = FALSE, full.names = TRUE)
  expect_true(length(subdirs) > 0)

  # Clean up the cache directory.
  unlink(cache_dir, recursive = TRUE)
})

test_that("rdd_to_txt fetches a specific package version when 'version' is provided", {
  skip_on_cran()
  skip_if_offline()

  cache_dir <- tempfile("cache_version_test")
  dir.create(cache_dir)

  # Use a package with a known version history, e.g., "jsonlite"
  # and a version that is not the latest.
  pkg_name <- "ini"
  pkg_version <- "0.1"

  old_repos <- getOption("repos")
  options(repos = c(CRAN = "https://cloud.r-project.org"))

  # Fetch the package with the specified version.
  out <- suppressWarnings(rdd_to_txt(
    pkg_name,
    version = pkg_version,
    force_fetch = TRUE,
    keep_files = "extracted",
    cache_path = cache_dir
  ))

  options(repos = old_repos)

  # Check that the extracted directory for the correct version exists.
  expected_dir <- file.path(cache_dir, pkg_name, pkg_version)
  expect_true(dir.exists(expected_dir))

  # Verify the version from the DESCRIPTION file.
  desc_file <- file.path(expected_dir, "DESCRIPTION")
  expect_true(file.exists(desc_file))

  desc_content <- readLines(desc_file)
  version_line <- grep("Version:", desc_content, value = TRUE)
  expect_true(grepl(pkg_version, version_line))

  # Clean up the cache directory.
  unlink(cache_dir, recursive = TRUE)
})

test_that("rdd_to_txt sets force_fetch=TRUE internally whenever 'version' is provided", {
  calls <- new.env(parent = emptyenv())
  calls$resolve_force_fetch <- NULL
  calls$rdd_force_fetch <- NULL

  fake_resolve_pkg_path_spy <- function(
    pkg,
    cache_path,
    force_fetch,
    version,
    repos
  ) {
    calls$resolve_force_fetch <- force_fetch
    list(
      pkg_path = tempfile("pkg_"),
      is_installed = FALSE,
      pkg_name = "ini",
      tar_path = NULL,
      version = version,
      extracted_path = NULL
    )
  }

  fake_rdd_extract_code_spy <- function(
    pkg,
    file,
    include_tests,
    include_roxygen,
    force_fetch,
    version,
    cache_path,
    keep_files
  ) {
    calls$rdd_force_fetch <- force_fetch
    "CODE"
  }

  # No-op helpers to avoid touching filesystem or requiring real pkg content
  fake_cleanup_files <- function(pkg_info, keep_files) invisible(NULL)
  fake_combine_rd <- function(...) "" # not used when content = "code"
  fake_combine_vignettes <- function(...) "" # not used when content = "code"

  local_mocked_bindings(
    resolve_pkg_path = fake_resolve_pkg_path_spy,
    rdd_extract_code = fake_rdd_extract_code_spy,
    cleanup_files = fake_cleanup_files,
    combine_rd = fake_combine_rd,
    combine_vignettes = fake_combine_vignettes,
    .package = "rdocdump"
  )

  out <- rdd_to_txt(
    "ini",
    version = "0.1", # << the trigger
    force_fetch = FALSE, # user-specified FALSE should be overridden
    content = "code",
    keep_files = "none"
  )

  expect_identical(out, "CODE")
  expect_true(isTRUE(calls$resolve_force_fetch))
  expect_true(isTRUE(calls$rdd_force_fetch))
})

test_that("rdd_to_txt passes through force_fetch unchanged when 'version' is NULL", {
  calls <- new.env(parent = emptyenv())
  calls$resolve_force_fetch <- NULL
  calls$rdd_force_fetch <- NULL

  fake_resolve_pkg_path_spy <- function(
    pkg,
    cache_path,
    force_fetch,
    version,
    repos
  ) {
    calls$resolve_force_fetch <- force_fetch
    list(
      pkg_path = tempfile("pkg_"),
      is_installed = FALSE,
      pkg_name = "ini",
      tar_path = NULL,
      version = version,
      extracted_path = NULL
    )
  }

  fake_rdd_extract_code_spy <- function(
    pkg,
    file,
    include_tests,
    include_roxygen,
    force_fetch,
    cache_path,
    version,
    keep_files
  ) {
    calls$rdd_force_fetch <- force_fetch
    "CODE"
  }

  fake_cleanup_files <- function(pkg_info, keep_files) invisible(NULL)
  fake_combine_rd <- function(...) ""
  fake_combine_vignettes <- function(...) ""

  local_mocked_bindings(
    resolve_pkg_path = fake_resolve_pkg_path_spy,
    rdd_extract_code = fake_rdd_extract_code_spy,
    cleanup_files = fake_cleanup_files,
    combine_rd = fake_combine_rd,
    combine_vignettes = fake_combine_vignettes,
    .package = "rdocdump"
  )

  # Case A: user passes force_fetch = FALSE, version = NULL -> internal should be FALSE
  out_A <- rdd_to_txt(
    "ini",
    version = NULL,
    force_fetch = FALSE,
    content = "code",
    keep_files = "none"
  )
  expect_identical(out_A, "CODE")
  expect_false(isTRUE(calls$resolve_force_fetch))
  expect_false(isTRUE(calls$rdd_force_fetch))

  # Reset captured values
  calls$resolve_force_fetch <- NULL
  calls$rdd_force_fetch <- NULL

  # Case B: user passes force_fetch = TRUE, version = NULL -> internal should be TRUE
  out_B <- rdd_to_txt(
    "ini",
    version = NULL,
    force_fetch = TRUE,
    content = "code",
    keep_files = "none"
  )
  expect_identical(out_B, "CODE")
  expect_true(isTRUE(calls$resolve_force_fetch))
  expect_true(isTRUE(calls$rdd_force_fetch))
})

#' Extract R Source Code from a Package
#'
#' @description
#' This function extracts the R source code from a package. For installed packages, it retrieves the package namespace and deparses all functions found in the package. For package source directories or archives (non-installed packages), it reads all `.R` files from the `R` directory and, optionally, from the `tests` directory. Optionally, it can include roxygen2 documentation from these files.
#'
#' @param pkg A `character` string specifying the package. This can be:
#' \itemize{
#' \item an installed package name,
#' \item a full path to a package source directory,
#' \item a full path to a package archive file (tar.gz), or
#' \item a package name not installed (which will then be downloaded from CRAN).
#' }
#' @param file Optional. Save path for the output text file. If set, the function will return the path to the file instead of the combined text. Defaults to `NULL`.
#' @param include_tests `logical`. If `TRUE`, for non-installed packages, the function will also include R source code from the `tests` directory. Defaults to `FALSE`.
#' @param include_roxygen `logical`. If `TRUE`, roxygen2 documentation lines (lines starting with "#'") from R files will be included in the output. Defaults to `FALSE`.
#' @param force_fetch `logical`. If `TRUE`, the package source will be fetched from CRAN even if the package is installed locally. Default is `FALSE`, but when `version` is specified, it will be set to `TRUE`.
#' @param version Optional. A `character` string specifying the package version to fetch from CRAN. If not provided, the latest version will be used.
#' @param cache_path A `character` string specifying the directory to use as a cache. Defaults to the value of `getOption("rdocdump.cache_path")`.
#'
#' @inheritParams rdd_to_txt
#'
#' @return A single string containing the combined R source code (and, optionally, roxygen2 documentation) from the package.
#'
#' @export
#'
#' @examples
#' # Extract only R source code (excluding roxygen2 documentation) from an installed package.
#' code <- rdd_extract_code("splines")
#' cat(substr(code, 1, 1000))
#'
#' # Extract R source code including roxygen2 documentation from a package source directory.
#' \donttest{
#' # set cache directory for `rdocdump`
#' rdd_set_cache_path(paste0(tempdir(), "/rdocdump_cache"))
#'
#' local({
#' code_with_roxygen <- rdd_extract_code(
#' "ini",
#' include_roxygen = TRUE,
#' force_fetch = TRUE,
#' repos = c("CRAN" = "https://cran.r-project.org")
#' )
#' cat(substr(code_with_roxygen, 1, 1000))
#'})
#'
#' # Extract R source code from a package source directory,
#' # including test files but excluding roxygen2 docs.
#' local({
#' code_with_tests <- rdd_extract_code(
#' "ini",
#' include_roxygen = TRUE,
#' include_tests = TRUE,
#' force_fetch = TRUE,
#' repos = c("CRAN" = "https://cran.r-project.org")
#' )
#' cat(substr(code_with_tests, 1, 1000))
#'})
#' # clean cache directory
#' unlink(getOption("rdocdump.cache_path"), recursive = TRUE, force = TRUE)
#' }
#'
rdd_extract_code <- function(
  pkg,
  file = NULL,
  include_tests = FALSE,
  include_roxygen = FALSE,
  force_fetch = FALSE,
  version = NULL,
  cache_path = getOption("rdocdump.cache_path"),
  keep_files = "none",
  repos = getOption("rdocdump.repos", getOption("repos"))
) {
  # Pass version to resolve_pkg_path and force fetching if a version is specified.
  pkg_info <- resolve_pkg_path(
    pkg,
    cache_path,
    force_fetch = force_fetch || !is.null(version),
    version = version,
    repos = repos
  )

  combined_code <- if (
    !is.null(pkg_info$is_installed) && pkg_info$is_installed
  ) {
    if (is.null(pkg_info$pkg_name)) {
      stop("Installed package does not provide pkg_name information.")
    }
    extract_code_installed(pkg_info$pkg_name)
  } else {
    extract_code_source(
      pkg_info$pkg_path,
      include_tests,
      include_roxygen
    )
  }

  # Clean up temporary files according to keep_files
  cleanup_result <- cleanup_files(pkg_info, keep_files)

  if (!is.null(file)) {
    writeLines(combined_code, con = file)
    return(file)
  }

  combined_code
}

#' Extract code from an installed package using its namespace.
#' This function retrieves all functions from the package namespace and deparses them to get their source code.
#' @param pkg_name The name of the installed package.
#' @return A single string containing the source code of all functions in the package.
#' @keywords internal
extract_code_installed <- function(pkg_name) {
  # Load the namespace of the installed package.
  ns <- asNamespace(pkg_name)

  obj_names <- ls(ns, all.names = TRUE)

  code_strings <- lapply(obj_names, function(nm) {
    obj <- get(nm, envir = ns)
    if (is.function(obj)) {
      # Deparse the function to retrieve its source code.
      code <- deparse(obj)
      header <- paste0(strrep("-", 80), "\nFunction: ", nm, "()\n")
      paste0(header, paste(code, collapse = "\n"))
    } else {
      NULL
    }
  })

  # Combine all function source codes.
  combined_code <- paste(unlist(code_strings), collapse = "\n\n")

  return(combined_code)
}

#' Helper function to extract code from package source files.
#' This function reads all `.R` files in the `R` directory and optionally includes files from the `tests` directory.
#' It can also exclude roxygen2 documentation lines.
#' @param pkg_path Path to the package source directory.
#' @inheritParams rdd_extract_code
#' @return A single string containing the source code from the package's R files.
#' @keywords internal
extract_code_source <- function(
  pkg_path,
  include_tests = FALSE,
  include_roxygen = FALSE
) {
  code_text <- ""

  # Read all .R files in the R directory.
  r_dir <- file.path(pkg_path, "R")
  if (dir.exists(r_dir)) {
    r_files <- list.files(r_dir, pattern = "\\.[rR]$", full.names = TRUE)
    for (rf in r_files) {
      header <- paste0(strrep("-", 80), "\nFile: ", basename(rf), "\n")
      file_content <- readLines(rf, warn = FALSE)

      # Exclude roxygen2 documentation if not requested.
      if (!include_roxygen) {
        file_content <- file_content[!grepl("^#'", file_content)]
      }

      code_text <- paste(
        code_text,
        header,
        paste(file_content, collapse = "\n"),
        "\n\n",
        sep = "\n"
      )
    }
  } else {
    warning("R directory not found in the package source.")
  }

  # Optionally, include R files from tests directory.
  if (include_tests) {
    tests_dir <- file.path(pkg_path, "tests")
    if (dir.exists(tests_dir)) {
      test_files <- list.files(
        tests_dir,
        pattern = "\\.[rR]$",
        full.names = TRUE
      )

      for (tf in test_files) {
        header <- paste0(strrep("-", 80), "\nTest File: ", basename(tf), "\n")
        file_content <- readLines(tf, warn = FALSE)
        if (!include_roxygen) {
          file_content <- file_content[!grepl("^#'", file_content)]
        }
        code_text <- paste(
          code_text,
          header,
          paste(file_content, collapse = "\n"),
          "\n\n",
          sep = "\n"
        )
      }
    }
  }

  return(code_text)
}

# before release
# usethis::use_version("patch")
usethis::use_tidy_description()
cffr::cff_write()
codemetar::write_codemeta(write_minimeta = T)
# urlchecker::url_check()
# devtools::check(remote = TRUE, manual = TRUE)
# devtools::check_win_devel()
# devtools::check_win_release()
# devtools::check_win_oldrelease()
# foghorn::winbuilder_queue()
# revdepcheck::revdep_check(num_workers = 4)

# devtools::submit_cran()

# usethis::use_github_release()
# usethis::use_dev_version(push = TRUE)

#' Cleanup Temporary Files
#'
#' @description
#' Clean up temporary package archive and extracted files according to a keep_files policy.
#'
#' @param pkg_info A list returned by `resolve_pkg_path()`, containing `tar_path` and `extracted_path`.
#'
#' @inheritParams rdd_to_txt
#'
#' @return Invisibly returns `NULL`. If there are any issues with file deletion, warnings are issued.
#'
#' @keywords internal
#'
cleanup_files <- function(
  pkg_info,
  keep_files
) {
  if (!keep_files %in% c("tgz", "both") && !is.null(pkg_info$tar_path)) {
    res <- unlink(pkg_info$tar_path)
    if (res != 0L) {
      warning(
        "cleanup_files: failed to delete archive: ",
        pkg_info$tar_path,
        call. = FALSE
      )
    }
  }

  if (
    !keep_files %in% c("extracted", "both") && !is.null(pkg_info$extracted_path)
  ) {
    dir_to_remove <- dirname(pkg_info$extracted_path)
    res <- unlink(dir_to_remove, recursive = TRUE)
    if (res != 0L) {
      warning(
        "cleanup_files: failed to delete extracted directory: ",
        dir_to_remove,
        call. = FALSE
      )
    }
  }

  invisible(NULL)
}

#' Combine Rd files into a single character vector.
#' This function reads the Rd files from a package source directory or an installed package and combines them into a single string.
#' @param pkg_path Path to the package source directory or the installed package.
#' @param is_installed Logical indicating whether the package is installed (`TRUE`) or a source package (`FALSE`).
#' @param pkg_name Optional package name if the package is installed.
#' @return A single string containing the combined Rd documentation.
#' @keywords internal
combine_rd <- function(
  pkg_path,
  is_installed = FALSE,
  pkg_name = NULL
) {
  if (is_installed) {
    # For installed packages, use the package name.
    rd_db <- tools::Rd_db(package = pkg_name)
  } else {
    # For source packages, use the directory with the raw Rd files.
    rd_db <- tools::Rd_db(dir = pkg_path)
  }

  rd_texts <- mapply(
    function(rd, rd_name) {
      txt <- utils::capture.output(tools::Rd2txt(Rd = rd))
      txt_clean <- gsub("_\b", "", txt, fixed = TRUE)
      # Extract function name by removing ".Rd" suffix from the file name.
      fname <- sub("\\.Rd$", "", rd_name)
      header_line <- paste0(strrep("-", 80), "\nFunction: ", fname, "()\n")
      paste0(header_line, paste(txt_clean, collapse = "\n"))
    },
    rd_db,
    names(rd_db),
    SIMPLIFY = FALSE
  )

  # Optionally include the DESCRIPTION file as a header.
  desc_file <- file.path(pkg_path, "DESCRIPTION")
  if (file.exists(desc_file)) {
    desc_text <- paste(readLines(desc_file), collapse = "\n")
    header <- paste0("DESCRIPTION:\n", desc_text, "\n\n")
  } else {
    header <- ""
  }

  combined_rd <- paste0(header, paste(unlist(rd_texts), collapse = "\n\n"))
  return(combined_rd)
}

test_that("combine_rd works for installed packages", {
  # For installed packages, pass the installed package path and package name.
  rd_text <- combine_rd(
    find.package("stats"),
    is_installed = TRUE,
    pkg_name = "stats"
  )

  expect_true(nchar(rd_text) > 0)
  expect_match(rd_text, "Function:")
})

test_that("combine_rd works for source packages", {
  # Create a dummy source package with minimal Rd documentation.
  temp_pkg <- tempfile("dummy_pkg")
  dir.create(temp_pkg)
  writeLines("Package: dummy\nVersion: 1.0", file.path(temp_pkg, "DESCRIPTION"))

  man_dir <- file.path(temp_pkg, "man")
  dir.create(man_dir)
  dummy_rd <- "\\name{dummy}\n\\alias{dummy}\n\\title{Dummy Function}\n\\description{A dummy function.}\n"
  writeLines(dummy_rd, file.path(man_dir, "dummy.Rd"))

  rd_text <- combine_rd(temp_pkg, is_installed = FALSE)

  expect_true(nchar(rd_text) > 0)
  expect_match(rd_text, "DESCRIPTION:")

  unlink(temp_pkg, recursive = TRUE)
})

test_that("combine_rd errors when DESCRIPTION file is missing", {
  temp_pkg <- tempfile("pkg_no_desc")
  dir.create(temp_pkg)

  # Do not create a DESCRIPTION file.
  man_dir <- file.path(temp_pkg, "man")
  dir.create(man_dir)
  writeLines(
    "\\name{nodef}\n\\alias{nodef}\n\\title{No Def Function}",
    file.path(man_dir, "nodef.Rd")
  )

  expect_error(
    combine_rd(temp_pkg, is_installed = FALSE),
    "Files 'DESCRIPTION' and 'DESCRIPTION.in' are missing."
  )

  unlink(temp_pkg, recursive = TRUE)
})

#' Helper function to combine package vignettes
#' @param pkg_path Path to the package source directory.
#' @return A single string containing the combined vignettes from the package.
#' @keywords internal
combine_vignettes <- function(pkg_path) {
  # Check for a "vignettes" directory; if not present, try "doc"
  if (dir.exists(file.path(pkg_path, "vignettes"))) {
    vignette_dir <- file.path(pkg_path, "vignettes")
  } else if (dir.exists(file.path(pkg_path, "doc"))) {
    vignette_dir <- file.path(pkg_path, "doc")
  } else {
    warning(
      "Neither 'vignettes' nor 'doc' directory found in the package source."
    )
    return("")
  }

  # List files with common vignette extensions: .Rmd, .Rnw, .md, .qmd
  vignette_files <- list.files(
    vignette_dir,
    pattern = "\\.(Rmd|Rnw|md|qmd)$",
    full.names = TRUE,
    ignore.case = TRUE
  )

  if (length(vignette_files) == 0) {
    warning("No vignette files found in the directory: ", vignette_dir)
    return("")
  }

  combined_text <- ""

  for (vf in vignette_files) {
    header_line <- paste0(strrep("-", 80), "\nVignette: ", basename(vf), "\n")
    text <- readLines(vf, warn = FALSE)
    combined_text <- paste(
      combined_text,
      header_line,
      paste(text, collapse = "\n"),
      "\n\n",
      sep = "\n"
    )
  }

  return(combined_text)
}

test_that("combine_vignettes works with a 'vignettes' directory", {
  pkg_dir <- tempfile("pkg_")
  dir.create(pkg_dir)
  vignette_dir <- file.path(pkg_dir, "vignettes")
  dir.create(vignette_dir)

  # Create a sample vignette file in vignettes directory
  vign_file <- file.path(vignette_dir, "example.Rmd")
  writeLines("This is an Rmd vignette", vign_file)

  out <- combine_vignettes(pkg_dir)
  expect_match(
    out,
    "Vignette: example\\.Rmd",
    info = "Should include the header with file name"
  )
  expect_match(
    out,
    "This is an Rmd vignette",
    info = "Should include the content of the vignette"
  )
})

test_that("combine_vignettes falls back to 'doc' directory if 'vignettes' is absent", {
  pkg_dir <- tempfile("pkg_")
  dir.create(pkg_dir)
  doc_dir <- file.path(pkg_dir, "doc")
  dir.create(doc_dir)

  # Create a sample vignette file in doc directory
  vign_file <- file.path(doc_dir, "example.qmd")
  writeLines("This is a qmd vignette", vign_file)

  out <- combine_vignettes(pkg_dir)
  expect_match(
    out,
    "Vignette: example\\.qmd",
    info = "Should include the header with file name from the doc folder"
  )
  expect_match(
    out,
    "This is a qmd vignette",
    info = "Should include the content of the vignette"
  )
})

test_that("combine_vignettes returns empty string if neither 'vignettes' nor 'doc' exists", {
  pkg_dir <- tempfile("pkg_")
  dir.create(pkg_dir)

  out <- suppressWarnings(combine_vignettes(pkg_dir))
  expect_equal(
    out,
    "",
    info = "Should return an empty string when no relevant directory is found"
  )
})

#' Resolve Remote Package References (GitHub, GitLab, Bitbucket)
#'
#' @description
#' Downloads package source from remote repositories (GitHub, GitLab, Bitbucket)
#' without installing the package. Uses the `remotes` package for downloading.
#'
#' @param pkg_ref A character string specifying the remote package reference.
#'   Supports formats like:
#'   - `"user/repo"` - GitHub shorthand (default)
#'   - `"github::user/repo"` - Explicit GitHub
#'   - `"gitlab::user/repo"` - GitLab
#'   - `"bitbucket::user/repo"` - Bitbucket
#'   - `"user/repo@ref"` - Specific commit, branch, or tag
#'   - `"user/repo/subdir"` - Package in subdirectory
#' @param cache_path Optional path to cache directory. If NULL, uses temp directory.
#'
#' @return A list containing:
#'   - `pkg_path`: Path to the package directory
#'   - `extracted_path`: Path to the extracted bundle
#'   - `tar_path`: Path to the downloaded tarball
#'   - `is_installed`: FALSE (always FALSE for remote packages)
#'   - `remote_info`: Parsed remote reference information
#'
#' @keywords internal
#'
resolve_remote_pkg <- function(pkg_ref, cache_path = NULL) {
  if (!is.character(pkg_ref) || length(pkg_ref) != 1L) {
    stop("Argument 'pkg_ref' must be a single character string.")
  }

  # Check if remotes package is installed
  if (!requireNamespace("remotes", quietly = TRUE)) {
    stop(
      "The 'remotes' package is required to download from remote repositories. ",
      "Please install it with: install.packages('remotes')"
    )
  }

  # Parse the remote reference
  parsed <- parse_remote_ref(pkg_ref)

  message(sprintf(
    "Downloading package from %s (%s/%s)...",
    parsed$type,
    parsed$user,
    parsed$repo
  ))

  # Create appropriate remote object
  remote <- create_remote(parsed)

  # Setup cache directory
  dest_dir <- get_remote_cache_dir(parsed, cache_path)

  # Ensure destination directory exists before downloading
  if (!dir.exists(dest_dir)) {
    dir.create(dest_dir, recursive = TRUE, showWarnings = FALSE)
  }

  # Download the bundle (NO INSTALLATION - just download)
  # remotes downloads to a temp file, so we need to move it to our cache
  temp_bundle <- tryCatch(
    remotes::remote_download(remote, quiet = TRUE),
    error = function(e) {
      stop(sprintf(
        "Failed to download remote package '%s': %s",
        pkg_ref,
        conditionMessage(e)
      ))
    }
  )

  # Move to our cache location
  bundle_path <- file.path(dest_dir, basename(temp_bundle))
  if (file.exists(bundle_path)) {
    file.remove(bundle_path)
  }
  file.copy(temp_bundle, bundle_path, overwrite = TRUE)
  # Clean up original temp file
  file.remove(temp_bundle)

  # Extract
  extract_dir <- file.path(dest_dir, "extracted")
  if (dir.exists(extract_dir)) {
    unlink(extract_dir, recursive = TRUE)
  }
  dir.create(extract_dir, recursive = TRUE, showWarnings = FALSE)

  utils::untar(bundle_path, exdir = extract_dir)

  # Flatten extra top-level folder if necessary (common in GitHub/GitLab bundles)
  subdirs <- list.dirs(extract_dir, recursive = FALSE, full.names = TRUE)
  if (length(subdirs) == 1L) {
    files <- list.files(
      subdirs[1],
      full.names = TRUE,
      all.files = TRUE,
      no.. = TRUE
    )
    file.copy(files, extract_dir, recursive = TRUE)
    unlink(subdirs[1], recursive = TRUE)
  }

  # Find package directory (handle subdirectories)
  pkg_path <- find_pkg_dir(extract_dir, parsed$subdir)

  # Validate it's a package
  if (!file.exists(file.path(pkg_path, "DESCRIPTION"))) {
    stop(sprintf(
      "Downloaded package does not contain a valid R package (no DESCRIPTION found). "
    ))
  }

  list(
    pkg_path = pkg_path,
    extracted_path = extract_dir,
    tar_path = bundle_path,
    is_installed = FALSE,
    pkg_name = parsed$repo,
    remote_info = parsed
  )
}

#' Parse Remote Reference String
#'
#' Supports formats:
#' - "user/repo" -> GitHub shorthand
#' - "github::user/repo" -> Explicit GitHub
#' - "gitlab::user/repo" -> GitLab
#' - "bitbucket::user/repo" -> Bitbucket
#' - "user/repo@ref" -> With commit/branch/tag
#' - "user/repo/subdir" -> With subdirectory
#' - "user/repo/subdir@ref" -> Combined
#' - "https://github.com/user/repo/tree/ref/subdir" -> Web URL
#'
#' @param ref Character string reference
#' @return List with components: type, user, repo, ref, subdir
#' @keywords internal
parse_remote_ref <- function(ref) {
  # Handle web URLs
  if (grepl("^https?://", ref)) {
    return(parse_remote_url(ref))
  }

  # Check for explicit type prefix
  type_pattern <- "^(github|gitlab|bitbucket|git|bioc)::"
  type_match <- regexpr(type_pattern, ref, perl = TRUE)

  if (type_match[1] != -1) {
    type <- regmatches(ref, type_match)
    type <- sub("::$", "", type)
    ref <- sub(type_pattern, "", ref)
  } else {
    # Default to GitHub for "user/repo" format
    type <- "github"
  }

  # Extract ref (commit/branch/tag) if present
  ref_pattern <- "@([^/@]+)$"
  ref_match <- regexpr(ref_pattern, ref, perl = TRUE)
  commit_ref <- NULL
  if (ref_match[1] != -1) {
    commit_ref <- regmatches(ref, ref_match)
    commit_ref <- sub("^@", "", commit_ref)
    ref <- sub(ref_pattern, "", ref)
  }

  # Split remaining path
  parts <- strsplit(ref, "/")[[1]]

  if (length(parts) < 2) {
    stop(sprintf(
      "Invalid remote reference '%s'. Expected format: 'user/repo' or 'user/repo/subdir'",
      ref
    ))
  }

  user <- parts[1]
  repo <- parts[2]

  # Everything after repo is subdirectory
  subdir <- NULL
  if (length(parts) > 2) {
    subdir <- paste(parts[3:length(parts)], collapse = "/")
  }

  list(
    type = type,
    user = user,
    repo = repo,
    ref = commit_ref,
    subdir = subdir,
    original = ref
  )
}

#' Parse GitHub or GitLab Web URL
#'
#' @param url The full URL string
#' @return List with components: type, user, repo, ref, subdir
#' @keywords internal
parse_remote_url <- function(url) {
  # Remove trailing slash
  url <- sub("/$", "", url)

  type <- NULL
  if (grepl("github\\.com", url)) {
    type <- "github"
  } else if (grepl("gitlab\\.com", url)) {
    type <- "gitlab"
  } else {
    stop("Only GitHub and GitLab URLs are currently supported.")
  }

  # GitHub: https://github.com/user/repo/tree/ref/subdir
  # GitLab: https://gitlab.com/user/repo/-/tree/ref/subdir
  pattern <- if (type == "github") {
    "^https?://github\\.com/([^/]+)/([^/]+)(/tree/|/blob/)?(.*)$"
  } else {
    "^https?://gitlab\\.com/([^/]+)/([^/]+)(/-/tree/|/-/blob/)?(.*)$"
  }

  matches <- regexec(pattern, url)
  parts <- regmatches(url, matches)[[1]]

  if (length(parts) < 3) {
    stop(sprintf("Could not parse %s URL: %s", type, url))
  }

  user <- parts[2]
  repo <- parts[3]
  ref_and_subdir <- if (length(parts) >= 5) parts[5] else ""

  # If there's no ref/subdir part, we're done
  if (ref_and_subdir == "") {
    return(list(
      type = type,
      user = user,
      repo = repo,
      ref = NULL,
      subdir = NULL,
      original = url
    ))
  }

  # Heuristic to split ref and subdir
  # 1. Common branches at the start
  common_branches <- c("main", "master", "develop", "dev", "trunk")
  ref <- NULL
  subdir <- NULL

  # Split by slash
  ref_parts <- strsplit(ref_and_subdir, "/")[[1]]

  if (ref_parts[1] %in% common_branches) {
    ref <- ref_parts[1]
    if (length(ref_parts) > 1) {
      subdir <- paste(ref_parts[2:length(ref_parts)], collapse = "/")
    }
  } else if (length(ref_parts) >= 2 &&
             ref_parts[1] %in% c("feature", "release", "hotfix", "patch")) {
    # Pattern: feature/branch-name/subdir
    ref <- paste(ref_parts[1:2], collapse = "/")
    if (length(ref_parts) > 2) {
      subdir <- paste(ref_parts[3:length(ref_parts)], collapse = "/")
    }
  } else {
    # Fallback: assume first part is ref
    ref <- ref_parts[1]
    if (length(ref_parts) > 1) {
      subdir <- paste(ref_parts[2:length(ref_parts)], collapse = "/")
    }
  }

  list(
    type = type,
    user = user,
    repo = repo,
    ref = ref,
    subdir = subdir,
    original = url
  )
}

#' Create Remote Object for remotes Package
#'
#' @param parsed Parsed reference from parse_remote_ref()
#' @return Remote object suitable for remotes::remote_download()
#' @keywords internal
create_remote <- function(parsed) {
  switch(
    parsed$type,
    github = remotes::github_remote(
      repo = paste(parsed$user, parsed$repo, sep = "/"),
      ref = parsed$ref %||% "HEAD",
      subdir = parsed$subdir
    ),
    gitlab = structure(
      list(
        host = "gitlab.com",
        repo = parsed$repo,
        subdir = parsed$subdir,
        username = parsed$user,
        ref = parsed$ref %||% "HEAD",
        sha = NULL,
        auth_token = NULL
      ),
      class = c("gitlab_remote", "remote")
    ),
    bitbucket = structure(
      list(
        host = "api.bitbucket.org/2.0",
        repo = parsed$repo,
        subdir = parsed$subdir,
        username = parsed$user,
        ref = parsed$ref %||% "HEAD",
        sha = NULL,
        auth_user = NULL,
        password = NULL
      ),
      class = c("bitbucket_remote", "remote")
    ),
    stop(sprintf(
      "Unsupported remote type '%s'. Supported: github, gitlab, bitbucket",
      parsed$type
    ))
  )
}

#' Get Cache Directory for Remote Package
#'
#' @param parsed Parsed reference
#' @param cache_path Base cache path
#' @return Path to cache directory
#' @keywords internal
get_remote_cache_dir <- function(parsed, cache_path) {
  if (!is.null(cache_path)) {
    ref_suffix <- parsed$ref %||% "HEAD"
    subdir_suffix <- if (!is.null(parsed$subdir)) {
      gsub("/", "_", parsed$subdir)
    } else {
      ""
    }

    dir_name <- paste(
      parsed$type,
      parsed$user,
      parsed$repo,
      ref_suffix,
      subdir_suffix,
      sep = "_"
    )
    dir_name <- gsub("_$", "", dir_name)

    file.path(cache_path, "remotes", dir_name)
  } else {
    tempfile(pattern = paste0("remote_", parsed$type, "_"))
  }
}

#' Find Package Directory Within Extracted Bundle
#'
#' @param extract_dir Directory where bundle was extracted
#' @param subdir Optional subdirectory path
#' @return Path to package directory
#' @keywords internal
find_pkg_dir <- function(extract_dir, subdir = NULL) {
  if (!is.null(subdir)) {
    # Use specified subdirectory
    pkg_path <- file.path(extract_dir, subdir)
    if (!dir.exists(pkg_path)) {
      stop(sprintf("Specified subdirectory '%s' not found in package", subdir))
    }
    return(pkg_path)
  }

  # Auto-detect: look for DESCRIPTION file
  # Usually the bundle extracts to a single directory
  subdirs <- list.dirs(extract_dir, recursive = FALSE, full.names = TRUE)

  if (length(subdirs) == 1) {
    # Single subdirectory - likely the package
    return(subdirs[1])
  }

  # Multiple items - check if any is a package
  for (dir in subdirs) {
    if (file.exists(file.path(dir, "DESCRIPTION"))) {
      return(dir)
    }
  }

  # Return extract_dir if nothing else found
  extract_dir
}

#' Check if String is a Remote Package Reference
#'
#' @param pkg Character string to check
#' @return TRUE if it looks like a remote reference
#' @keywords internal
#'
is_remote_reference <- function(pkg) {
  if (!is.character(pkg) || length(pkg) != 1L) {
    return(FALSE)
  }

  # Check for explicit type prefix
  if (grepl("^(github|gitlab|bitbucket|git|bioc)::", pkg)) {
    return(TRUE)
  }

  # Check for web URLs
  if (grepl("^https?://(github\\.com|gitlab\\.com)/", pkg)) {
    return(TRUE)
  }

  # Check for user/repo pattern (GitHub shorthand)
  # Must have exactly one / with valid characters on both sides.
  # We use a slightly more restrictive regex to avoid matching local paths.
  # GitHub usernames can be alphanumeric with hyphens.
  # Repo names can be alphanumeric with hyphens, underscores, and dots.
  if (grepl("^[a-zA-Z0-9-]{1,39}/[a-zA-Z0-9._-]{1,100}(@|/|$)", pkg)) {
    # Make sure it's not an absolute or relative path
    if (!grepl("^(/|[A-Za-z]:|\\.|~)", pkg)) {
      return(TRUE)
    }
  }

  FALSE
}

#' Helper: NULL default operator
#' @keywords internal
#' @noRd
`%||%` <- function(x, y) if (is.null(x)) y else x

test_that("is_remote_reference detects remote references correctly", {
  # GitHub shorthand
  expect_true(is_remote_reference("user/repo"))
  expect_true(is_remote_reference("tidyverse/ggplot2"))
  expect_true(is_remote_reference("r-lib/rlang"))

  # Explicit types
  expect_true(is_remote_reference("github::user/repo"))
  expect_true(is_remote_reference("gitlab::user/repo"))
  expect_true(is_remote_reference("bitbucket::user/repo"))

  # With refs
  expect_true(is_remote_reference("user/repo@main"))
  expect_true(is_remote_reference("user/repo@v1.0.0"))
  expect_true(is_remote_reference("user/repo@abc123"))

  # With subdirs
  expect_true(is_remote_reference("user/repo/subdir"))
  expect_true(is_remote_reference("user/repo/pkg/subdir"))

  # Combined
  expect_true(is_remote_reference("user/repo/subdir@main"))

  # Not remote references
  expect_false(is_remote_reference("ggplot2"))
  expect_false(is_remote_reference("/path/to/pkg"))
  expect_false(is_remote_reference("./local/pkg"))
  expect_false(is_remote_reference("~/home/pkg"))
  expect_false(is_remote_reference("C:\\Windows\\pkg"))
  expect_false(is_remote_reference(NULL))
  expect_false(is_remote_reference(123))
  expect_false(is_remote_reference(c("a", "b")))
})

test_that("parse_remote_ref parses GitHub shorthand correctly", {
  p <- parse_remote_ref("user/repo")
  expect_equal(p$type, "github")
  expect_equal(p$user, "user")
  expect_equal(p$repo, "repo")
  expect_null(p$ref)
  expect_null(p$subdir)
})

test_that("parse_remote_ref parses explicit GitHub correctly", {
  p <- parse_remote_ref("github::tidyverse/ggplot2")
  expect_equal(p$type, "github")
  expect_equal(p$user, "tidyverse")
  expect_equal(p$repo, "ggplot2")
})

test_that("parse_remote_ref parses GitLab correctly", {
  p <- parse_remote_ref("gitlab::user/repo")
  expect_equal(p$type, "gitlab")
  expect_equal(p$user, "user")
  expect_equal(p$repo, "repo")
})

test_that("parse_remote_ref parses Bitbucket correctly", {
  p <- parse_remote_ref("bitbucket::user/repo")
  expect_equal(p$type, "bitbucket")
  expect_equal(p$user, "user")
  expect_equal(p$repo, "repo")
})

test_that("parse_remote_ref handles refs correctly", {
  p <- parse_remote_ref("user/repo@main")
  expect_equal(p$ref, "main")
  expect_equal(p$repo, "repo")

  p <- parse_remote_ref("user/repo@v1.0.0")
  expect_equal(p$ref, "v1.0.0")

  p <- parse_remote_ref("user/repo@abc123def")
  expect_equal(p$ref, "abc123def")
})

test_that("parse_remote_ref handles subdirectories correctly", {
  p <- parse_remote_ref("user/repo/subdir")
  expect_equal(p$subdir, "subdir")

  p <- parse_remote_ref("user/repo/nested/subdir")
  expect_equal(p$subdir, "nested/subdir")
})

test_that("parse_remote_ref handles combined refs and subdirs", {
  p <- parse_remote_ref("user/repo/subdir@main")
  expect_equal(p$type, "github")
  expect_equal(p$user, "user")
  expect_equal(p$repo, "repo")
  expect_equal(p$subdir, "subdir")
  expect_equal(p$ref, "main")
})

test_that("parse_remote_ref errors on invalid references", {
  expect_error(parse_remote_ref("invalid"), "Invalid remote reference")
  expect_error(parse_remote_ref("user"), "Invalid remote reference")
  # Note: "/user/repo" is not detected as remote by is_remote_reference
  # but parse_remote_ref will error because it only has one part after removing type
})

test_that("get_remote_cache_dir creates correct paths", {
  p <- list(
    type = "github",
    user = "tidyverse",
    repo = "ggplot2",
    ref = NULL,
    subdir = NULL
  )
  path <- get_remote_cache_dir(p, "/cache")
  expect_match(path, "/cache/remotes/github_tidyverse_ggplot2_HEAD$")

  p$ref <- "main"
  path <- get_remote_cache_dir(p, "/cache")
  expect_match(path, "/cache/remotes/github_tidyverse_ggplot2_main$")

  p$subdir <- "pkg/subdir"
  path <- get_remote_cache_dir(p, "/cache")
  expect_match(path, "github_tidyverse_ggplot2_main_pkg_subdir$")
})

test_that("find_pkg_dir finds package directory correctly", {
  # Create temp structure
  temp_dir <- tempfile()
  dir.create(temp_dir)
  pkg_dir <- file.path(temp_dir, "mypackage")
  dir.create(pkg_dir)
  writeLines("Package: mypackage", file.path(pkg_dir, "DESCRIPTION"))

  # Should find the subdirectory
  found <- find_pkg_dir(temp_dir, NULL)
  expect_equal(found, pkg_dir)

  # Cleanup
  unlink(temp_dir, recursive = TRUE)
})

test_that("find_pkg_dir handles specified subdirectory", {
  temp_dir <- tempfile()
  dir.create(temp_dir)
  sub_dir <- file.path(temp_dir, "nested", "pkg")
  dir.create(sub_dir, recursive = TRUE)
  writeLines("Package: pkg", file.path(sub_dir, "DESCRIPTION"))

  found <- find_pkg_dir(temp_dir, "nested/pkg")
  expect_equal(found, sub_dir)

  unlink(temp_dir, recursive = TRUE)
})

test_that("is_remote_reference detects web URLs correctly", {
  expect_true(is_remote_reference("https://github.com/user/repo"))
  expect_true(is_remote_reference("http://github.com/user/repo"))
  expect_true(is_remote_reference("https://gitlab.com/user/repo"))
  expect_true(is_remote_reference("https://github.com/user/repo/tree/main/subdir"))
})

test_that("parse_remote_url parses GitHub URLs correctly", {
  # Simple
  p <- parse_remote_url("https://github.com/user/repo")
  expect_equal(p$type, "github")
  expect_equal(p$user, "user")
  expect_equal(p$repo, "repo")
  expect_null(p$ref)
  expect_null(p$subdir)

  # With branch
  p <- parse_remote_url("https://github.com/user/repo/tree/master")
  expect_equal(p$ref, "master")
  expect_null(p$subdir)

  # With branch and subdir
  p <- parse_remote_url("https://github.com/apache/sedona-db/tree/main/r/sedonadb")
  expect_equal(p$user, "apache")
  expect_equal(p$repo, "sedona-db")
  expect_equal(p$ref, "main")
  expect_equal(p$subdir, "r/sedonadb")

  # With complex branch
  p <- parse_remote_url("https://github.com/user/repo/tree/feature/cool-stuff/pkg")
  expect_equal(p$ref, "feature/cool-stuff")
  expect_equal(p$subdir, "pkg")
})

test_that("parse_remote_url parses GitLab URLs correctly", {
  p <- parse_remote_url("https://gitlab.com/user/repo/-/tree/main/subdir")
  expect_equal(p$type, "gitlab")
  expect_equal(p$user, "user")
  expect_equal(p$repo, "repo")
  expect_equal(p$ref, "main")
  expect_equal(p$subdir, "subdir")
})

test_that("create_remote creates correct remote objects", {
  # GitHub
  p <- list(
    type = "github",
    user = "r-lib",
    repo = "rlang",
    ref = "main",
    subdir = NULL
  )
  remote <- create_remote(p)
  expect_s3_class(remote, "github_remote")

  # GitLab
  p <- list(
    type = "gitlab",
    user = "user",
    repo = "repo",
    ref = "HEAD",
    subdir = NULL
  )
  remote <- create_remote(p)
  expect_s3_class(remote, "gitlab_remote")
  expect_equal(remote$host, "gitlab.com")
  expect_equal(remote$repo, "repo")

  # Bitbucket
  p <- list(
    type = "bitbucket",
    user = "user",
    repo = "repo",
    ref = "HEAD",
    subdir = NULL
  )
  remote <- create_remote(p)
  expect_s3_class(remote, "bitbucket_remote")
  expect_equal(remote$host, "api.bitbucket.org/2.0")
  expect_equal(remote$repo, "repo")

  # Unsupported type
  p <- list(
    type = "unknown",
    user = "user",
    repo = "repo",
    ref = NULL,
    subdir = NULL
  )
  expect_error(create_remote(p), "Unsupported remote type")
})

# Integration tests - only run when online
test_that("resolve_remote_pkg downloads GitHub package correctly", {
  skip_if_offline()
  skip_on_cran()

  cache <- tempfile()
  dir.create(cache)

  # Use a small, stable repo
  info <- resolve_remote_pkg("r-lib/crayon", cache_path = cache)

  expect_true(dir.exists(info$pkg_path))
  expect_true(file.exists(file.path(info$pkg_path, "DESCRIPTION")))
  expect_false(info$is_installed)
  expect_equal(info$remote_info$type, "github")
  expect_equal(info$remote_info$user, "r-lib")
  expect_equal(info$remote_info$repo, "crayon")

  # Cleanup
  unlink(cache, recursive = TRUE)
})

test_that("resolve_remote_pkg handles branches correctly", {
  skip_if_offline()
  skip_on_cran()

  cache <- tempfile()
  dir.create(cache)

  info <- resolve_remote_pkg("r-lib/crayon@main", cache_path = cache)

  expect_true(dir.exists(info$pkg_path))
  expect_equal(info$remote_info$ref, "main")

  unlink(cache, recursive = TRUE)
})

test_that("resolve_remote_pkg caches correctly", {
  skip_if_offline()
  skip_on_cran()

  cache <- tempfile()
  dir.create(cache)

  # First download
  info1 <- resolve_remote_pkg("r-lib/crayon", cache_path = cache)

  # Second download should use cache
  info2 <- resolve_remote_pkg("r-lib/crayon", cache_path = cache)

  expect_equal(info1$pkg_path, info2$pkg_path)
  expect_true(file.exists(info1$tar_path))

  unlink(cache, recursive = TRUE)
})

#' Set `rdocdump` Repository Options
#'
#' @description
#' This function sets the package repository URLs used by `rdocdump` when fetching package sources. May be useful for setting custom repositories or mirrors. This does not affect the repositories used by `install.packages()` in your current R session and/or project.
#'
#' @param repos A character vector of repository URLs.
#'
#' @return Invisibly returns the new repository URLs.
#'
#' @examples
#' # Set rdocdump repository options
#' rdd_set_repos(c("CRAN" = "https://cloud.r-project.org"))
#'
#' @export
rdd_set_repos <- function(repos) {
  if (!is.character(repos)) {
    stop("repos must be a character vector of repository URLs.")
  }
  options(rdocdump.repos = repos)
  message("rdocdump.repos set to: ", paste(repos, collapse = ", "))
  invisible(getOption("rdocdump.repos"))
}

#' Get Current `rdocdump` Repository Options
#'
#' @description
#' This function returns the current repository URLs used by `rdocdump`. The default is set to the CRAN repository at "https://cloud.r-project.org". This does not affect the repositories used by `install.packages()` in your current R session and/or project. To set repository options, use \code{\link{rdd_set_repos}}.
#'
#' @return A character vector of repository URLs.
#'
#' @examples
#' # Get current rdocdump repository options
#' rdd_get_repos()
#'
#' @export
rdd_get_repos <- function() {
  getOption("rdocdump.repos", getOption("repos"))
}

#' Set `rdocdump` Cache Path in the Current R Session
#'
#' @description
#' This function sets the cache path used by `rdocdump` to store temporary files (downloaded tar.gz archives and/or extracted directories) for the current R session. The cache path is stored in the option `"rdocdump.cache_path"`, which can be checked with `getOption("rdocdump.cache_path")`. The path is created if it does not exist.
#'
#' @param path A `character` string specifying the directory to be used as the cache path.
#'
#' @return Invisibly returns the new cache path.
#' @export
#' @examples
#' # set cache directory for `rdocdump`
#' rdd_set_cache_path(paste0(tempdir(), "/rdocdump_cache"))
#' # default cache directory
#' unlink(getOption("rdocdump.cache_path"), recursive = TRUE)
rdd_set_cache_path <- function(
  path
) {
  # Validate the input path
  if (!is.character(path) || length(path) != 1) {
    stop(
      "`path` argument must be a single character string specifying the cache directory."
    )
  }

  if (!dir.exists(path)) {
    dir.create(path, recursive = TRUE)
  }
  options(rdocdump.cache_path = normalizePath(path, winslash = "/"))
  message("rdocdump.cache_path set to: ", getOption("rdocdump.cache_path"))
  invisible(getOption("rdocdump.cache_path"))
}

test_that("rdd_set_cache_path sets the cache path correctly", {
  temp_cache <- tempfile("rdocdump_cache")
  on.exit(unlink(temp_cache, recursive = TRUE), add = TRUE)

  # <<< NEW: scope any existing option so it's auto-restored at test end
  withr::local_options(list(
    rdocdump.cache_path = getOption("rdocdump.cache_path")
  ))

  result <- rdd_set_cache_path(temp_cache)
  normalized_path <- normalizePath(temp_cache, winslash = "/")

  expect_equal(getOption("rdocdump.cache_path"), normalized_path)
  expect_equal(result, normalized_path)
})

#' Resolve the path to a package directory or tarball
#' @description
#' This function resolves the path to a package directory or tarball, handling both installed packages and source packages from CRAN.
#' @inheritParams rdd_to_txt
#' @return A list containing:
#' - `pkg_path`: Path to the package directory or tarball.
#' - `extracted_path`: Path to the extracted package directory (if applicable).
#' - `tar_path`: Path to the tarball if it was downloaded.
#' - `is_installed`: Logical indicating if the package is installed.
#'
#' @keywords internal
#'
resolve_pkg_path <- function(
  pkg,
  cache_path = NULL,
  force_fetch = FALSE,
  version = NULL,
  repos = getOption("rdocdump.repos", getOption("repos"))
) {
  if (!is.character(pkg) || length(pkg) != 1L) {
    stop("Argument 'pkg' must be a single character string.")
  }

  # Helper function to parse tarball filename into package name and version.
  parse_tarball_name <- function(tar_path) {
    base_name <- basename(tar_path) # e.g., "rJavaEnv_0.2.2.tar.gz"
    folder_name <- sub("\\.tar\\.gz$", "", base_name)
    parts <- strsplit(folder_name, "_")[[1]]
    if (length(parts) < 2) {
      stop(
        "Tarball filename does not conform to the expected pattern 'pkgname_version.tar.gz'."
      )
    }
    version <- parts[length(parts)]
    pkgname <- paste(parts[-length(parts)], collapse = "_")
    list(pkgname = pkgname, version = version)
  }

  # Helper function to determine extraction directory.
  get_extract_dir <- function(tar_path) {
    info <- parse_tarball_name(tar_path)
    if (!is.null(cache_path)) {
      file.path(cache_path, info$pkgname, info$version)
    } else {
      tempfile(paste0(info$pkgname, "_", info$version))
    }
  }

  if (file.exists(pkg)) {
    if (dir.exists(pkg)) {
      # Check if directory is a source package by looking for Rd files in "man/"
      man_dir <- file.path(pkg, "man")
      rd_files <- if (dir.exists(man_dir)) {
        list.files(man_dir, pattern = "\\.Rd$", full.names = TRUE)
      } else {
        character(0)
      }
      if (length(rd_files) > 0) {
        # It is a source package
        return(list(
          pkg_path = pkg,
          extracted_path = NULL,
          tar_path = NULL,
          is_installed = FALSE
        ))
      } else {
        # No .Rd files found in "man/" -> assume it's an installed package.
        return(list(
          pkg_path = pkg,
          extracted_path = NULL,
          tar_path = NULL,
          is_installed = TRUE,
          pkg_name = pkg
        ))
      }
    } else {
      # pkg is a file; assume it is a tar.gz archive.
      if (!grepl("\\.tar\\.gz$", pkg)) {
        stop(
          "The specified file is not a recognized package archive (expected extension .tar.gz)."
        )
      }
      extract_dir <- get_extract_dir(pkg)
      if (!dir.exists(extract_dir)) {
        dir.create(extract_dir, recursive = TRUE)
      }
      utils::untar(pkg, exdir = extract_dir)
      # Flatten extra top-level folder if necessary.
      subdirs <- list.dirs(extract_dir, recursive = FALSE, full.names = TRUE)
      if (length(subdirs) == 1L) {
        files <- list.files(
          subdirs[1],
          full.names = TRUE,
          all.files = TRUE,
          no.. = TRUE
        )
        file.copy(files, extract_dir, recursive = TRUE)
        unlink(subdirs[1], recursive = TRUE)
      }
      return(list(
        pkg_path = extract_dir,
        extracted_path = extract_dir,
        tar_path = NULL,
        is_installed = FALSE
      ))
    }
  } else {
    # pkg is not an existing file/directory: treat it as a package name.
    # If force_fetch is TRUE, ignore any locally installed package.
    pkg_found <- if (!force_fetch) {
      tryCatch(find.package(pkg), error = function(e) NULL)
    } else {
      NULL
    }
    if (!is.null(pkg_found) && is.null(version)) {
      # Installed package found.
      return(list(
        pkg_path = pkg_found,
        extracted_path = NULL,
        tar_path = NULL,
        is_installed = TRUE,
        pkg_name = pkg
      ))
    } else {
      message("Fetching package source from CRAN...")
      dest_dir <- if (!is.null(cache_path)) cache_path else tempdir()
      if (!dir.exists(dest_dir)) {
        dir.create(dest_dir, recursive = TRUE)
      }
      # Warn if repos contains known problematic URLs.
      if (
        any(grepl("posit\\.co|r-universe\\.dev", repos, ignore.case = TRUE))
      ) {
        warning(
          "Using a repository URL from posit.co or r-universe.dev may result in pre-built binaries being downloaded instead of the package source."
        )
      }

      if (!is.null(version)) {
        # Construct URL for a specific version.
        repo_url <- repos[1] # Use the first repo.
        tar_filename <- paste0(pkg, "_", version, ".tar.gz")
        # Try archive first.
        url <- file.path(repo_url, "src/contrib/Archive", pkg, tar_filename)
        # Try downloading.
        res <- try(
          suppressWarnings(
            utils::download.file(
              url,
              destfile = file.path(dest_dir, tar_filename),
              mode = "wb",
              quiet = TRUE
            )
          ),
          silent = TRUE
        )
        # If archive fails, try main contrib.
        if (inherits(res, "try-error") || res != 0) {
          url <- file.path(repo_url, "src/contrib", tar_filename)
          res <- try(
            suppressWarnings(
              utils::download.file(
                url,
                destfile = file.path(dest_dir, tar_filename),
                mode = "wb",
                quiet = TRUE
              )
            ),
            silent = TRUE
          )
        }
        if (inherits(res, "try-error") || res != 0) {
          stop(paste(
            "Could not download package",
            pkg,
            "version",
            version,
            "from",
            url
          ))
        }
        dp <- matrix(
          c(tar_filename, file.path(dest_dir, tar_filename)),
          nrow = 1
        )
      } else {
        dp <- utils::download.packages(
          pkg,
          destdir = dest_dir,
          type = "source",
          repos = repos
        )
      }

      if (nrow(dp) < 1L) {
        stop("Package not found on CRAN.")
      }
      archive <- dp[, 2]
      base_name <- basename(archive)
      # If cache_path is provided, move the archive there.
      if (!is.null(cache_path)) {
        dest_archive <- file.path(cache_path, base_name)
        file.rename(archive, dest_archive)
        archive <- dest_archive
      }
      extract_dir <- get_extract_dir(archive)
      if (!dir.exists(extract_dir)) {
        dir.create(extract_dir, recursive = TRUE)
      }
      utils::untar(archive, exdir = extract_dir)
      subdirs <- list.dirs(extract_dir, recursive = FALSE, full.names = TRUE)
      if (length(subdirs) == 1L) {
        files <- list.files(
          subdirs[1],
          full.names = TRUE,
          all.files = TRUE,
          no.. = TRUE
        )
        file.copy(files, extract_dir, recursive = TRUE)
        unlink(subdirs[1], recursive = TRUE)
      }
      return(list(
        pkg_path = extract_dir,
        extracted_path = extract_dir,
        tar_path = archive,
        is_installed = FALSE
      ))
    }
  }
}

test_that("resolve_pkg_path identifies installed packages correctly", {
  # Use a base package, such as "stats", which is always installed.
  pkg_info <- resolve_pkg_path("stats", force_fetch = FALSE)

  expect_true(pkg_info$is_installed)
  expect_equal(pkg_info$pkg_name, "stats")
  expect_equal(pkg_info$pkg_path, find.package("stats"))
})

test_that("resolve_pkg_path identifies a source package directory", {
  # Create a dummy source package directory.
  temp_pkg <- tempfile("dummy_pkg")
  dir.create(temp_pkg)
  writeLines("Package: dummy\nVersion: 1.0", file.path(temp_pkg, "DESCRIPTION"))

  # Create a 'man' directory with a dummy Rd file.
  man_dir <- file.path(temp_pkg, "man")
  dir.create(man_dir)
  dummy_rd <- "\\name{dummy}\n\\alias{dummy}\n\\title{Dummy Function}\n\\description{A dummy function.}\n"
  writeLines(dummy_rd, file.path(man_dir, "dummy.Rd"))

  pkg_info <- resolve_pkg_path(temp_pkg)
  expect_false(pkg_info$is_installed)
  expect_equal(pkg_info$pkg_path, temp_pkg)

  unlink(temp_pkg, recursive = TRUE)
})


test_that("resolve_pkg_path handles tar.gz archive file correctly", {
  # Create a temporary dummy package directory with minimal files.
  dummy_pkg <- tempfile("dummy_pkg")
  dir.create(dummy_pkg)
  writeLines(
    "Package: dummy\nVersion: 1.0",
    file.path(dummy_pkg, "DESCRIPTION")
  )
  man_dir <- file.path(dummy_pkg, "man")
  dir.create(man_dir)
  writeLines(
    "\\name{dummy}\n\\alias{dummy}\n\\title{Dummy Function}",
    file.path(man_dir, "dummy.Rd")
  )

  # Create a tar.gz archive of the dummy package.
  tar_path <- tempfile("dummy_pkg", fileext = ".tar.gz")
  old_wd <- getwd()
  setwd(dirname(dummy_pkg))
  # Create the archive without extra arguments.
  utils::tar(tarfile = tar_path, files = basename(dummy_pkg), tar = "internal")
  setwd(old_wd)

  expect_true(file.exists(tar_path)) # Ensure archive exists

  # Call the actual function with an explicit cache_path to force extraction.
  pkg_info <- resolve_pkg_path(tar_path, cache_path = tempdir())

  expect_false(pkg_info$is_installed)
  # With cache_path specified, get_extract_dir() should return a directory path.
  expect_true(is.character(pkg_info$pkg_path))
  expect_true(is.character(pkg_info$extracted_path))
  expect_equal(pkg_info$pkg_path, pkg_info$extracted_path)
  expect_true(dir.exists(pkg_info$pkg_path))

  # Clean up.
  unlink(pkg_info$pkg_path, recursive = TRUE)
  unlink(tar_path)
})


test_that("resolve_pkg_path fetches package from CRAN", {
  skip_on_cran()
  skip_if_offline()

  package <- "ini" # choosing a minimal size stable package
  old_repos <- getOption("repos")
  options(repos = c(CRAN = "https://cloud.r-project.org"))
  pkg_info <- resolve_pkg_path(
    package,
    cache_path = tempdir(),
    force_fetch = TRUE
  )
  options(repos = old_repos)

  expect_true(file.exists(pkg_info$tar_path))
  expect_true(dir.exists(pkg_info$pkg_path))
  unlink(pkg_info$pkg_path, recursive = TRUE)
  unlink(pkg_info$tar_path)
})

---
title: "Quick Start: dump R docs and vignettes to text files for LLMs"
vignette: >
  %\VignetteIndexEntry{Quick Start: dump R docs and vignettes to text files for LLMs}
  %\VignetteEngine{quarto::html}
  %\VignetteEncoding{UTF-8}
execute:
  eval: false
format:
  html:
    toc: true
    toc-depth: 2
    code-overflow: wrap
---

# Introduction

`{rdocdump}` is an R package designed to combine an R package’s documentation and vignettes into a single plain text file. This is particularly useful when you want to ingest complete package documentation into large language models (LLMs) or for archival purposes. `{rdocdump}` works with installed packages, source directories, tar.gz archives, or package sources available on CRAN.

# Installation


Install the latest stable release of `rdocdump` from CRAN with:

```r
install.packages("rdocdump")
```

You can install the development version of `rdocdump` from R Universe with:

```r
install.packages('rdocdump',
 repos = c('https://e-kotov.r-universe.dev', 'https://cloud.r-project.org')
)
```

or from GitHub with:

```r
# install.packages("pak")
pak::pak("e-kotov/rdocdump")
```


# Setting the Cache Path

By default, `{rdocdump}` stores temporary files in a directory within R’s temporary directory. You can override this by setting a custom cache path using the helper function `rdd_set_cache_path()`. For example:

```r
# Set a custom cache directory
cache_dir <- file.path(tempdir(), "my_rdocdump_cache")
rdd_set_cache_path(cache_dir)
```

```
rdocdump.cache_path set to: /private/var/folders/gb/t5zr5rn15sldqybrmqbyh6y80000gn/T/Rtmpp5wRxV/my_rdocdump_cache
```

This ensures that temporary tar.gz archives and extracted files are stored in your specified directory.

# Extracting Documentation

The main function in rdocdump is `rdd_to_txt()`, which accepts several types of inputs for the `pkg` argument:

- An installed package name (e.g., `"stats"`).

- A full path to a package source directory.

- A full path to a package archive (tar.gz).

- A package name available on CRAN (downloaded automatically if not installed).

Here is an example that downloads the source for the package `{rJavaEnv}` from CRAN, extracts its documentation, and saves it to a file:

```r
# Extract documentation for 'rJavaEnv' and save to a text file.
rdd_to_txt(
  pkg = "rJavaEnv",
  file = tempfile("rJavaEnv_docs_", fileext = ".txt"),
  force_fetch = TRUE,    # Force download even if the package is installed.
  keep_files = "none"      # Delete temporary files after extraction.
)
```

```
Fetching package source from CRAN...
trying URL 'https://cloud.r-project.org/src/contrib/rJavaEnv_0.3.0.tar.gz'
Content type 'application/x-gzip' length 104016 bytes (101 KB)
==================================================
downloaded 101 KB

[1] "/private/var/folders/gb/t5zr5rn15sldqybrmqbyh6y80000gn/T/Rtmpp5wRxV/rJavaEnv_docs_c0736421bbc2.txt"
```

If you prefer to simply get the combined documentation as a character string, call the function without the `file` argument:

```r
# Extract and capture the combined documentation in a variable.
docs <- rdd_to_txt(pkg = "splines")
cat(substr(docs, 1, 1000))  # Print the first 1000 characters for a preview.
```

```
DESCRIPTION:
Package: splines
Version: 4.5.1
Priority: base
Imports: graphics, stats
Title: Regression Spline Functions and Classes
Author: Douglas M. Bates <bates@stat.wisc.edu> and
 William N. Venables <Bill.Venables@csiro.au>
Maintainer: R Core Team <do-use-Contact-address@r-project.org>
Contact: R-help mailing list <r-help@r-project.org>
Description: Regression spline functions and classes.
License: Part of R 4.5.1
Suggests: Matrix, methods
NeedsCompilation: yes
Built: R 4.5.1; aarch64-apple-darwin20; 2025-06-14 01:29:30 UTC; unix

--------------------------------------------------------------------------------
Function: asVector()
Coerce an Object to a Vector

Description:

     This is a generic function.  Methods for this function coerce
     objects of given classes to vectors.

Usage:

     asVector(object)
     
Arguments:

  object: An object.

Details:

     Methods for vector coercion in new classes must be created for the
     ‘asVector’ generic instead of ‘as.vector’.
```

# Choosing what to dump to text

You can also choose if you want just the package documentaiton, just the vignettes, or both to be combined with the `content` argument:

```r
docs <- rdd_to_txt(
  pkg = "utils",
  content = "vignettes"
)
cat(substr(docs, 1, 1000))  # Print the first 1000 characters for a preview.
```

As you can see below, only the vignettes were combined:

```
--------------------------------------------------------------------------------
Vignette: Sweave.Rnw

% File src/library/utils/vignettes/Sweave.Rnw
% Part of the R package, https://www.R-project.org
% Copyright 2002-2022 Friedrich Leisch and the R Core Team
% Distributed under GPL 2 or later

\documentclass[a4paper]{article}

%\VignetteIndexEntry{Sweave User Manual}
%\VignettePackage{utils}
%\VignetteDepends{tools, datasets, stats, graphics}

\title{Sweave User Manual}
\author{Friedrich Leisch and R Core Team}

\usepackage[round]{natbib}
\usepackage{graphicx, Rd}
\usepackage{listings}

\lstset{frame=trbl,basicstyle=\small\tt}
\usepackage{hyperref}
\usepackage{color}
\definecolor{Blue}{rgb}{0,0,0.8}
\hypersetup{%
colorlinks,%
plainpages=true,%
linkcolor=black,%
citecolor=black,%
urlcolor=Blue,%
%pdfstartview=FitH,% or Fit
pdfstartview={XYZ null null 1},%
pdfview={XYZ null null null},%
pdfpagemode=UseNone,% for no outline
pdfauthor={Friedrich Leisch and R Core Team},%
pdftitle={Sweave 
```

# Handling Temporary Files

The argument `keep_files` controls whether temporary files (the downloaded archive and/or extracted directory) are retained:

- `"none"` (default): Delete both the tar.gz archive and the extracted files.

- `"tgz"`: Keep only the tar.gz archive.

- `"extracted"`: Keep only the extracted files.

- `"both"`: Keep both the tar.gz archive and the extracted files.

Choose the option that best fits your workflow.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{is_remote_reference}
\alias{is_remote_reference}
\title{Check if String is a Remote Package Reference}
\usage{
is_remote_reference(pkg)
}
\arguments{
\item{pkg}{Character string to check}
}
\value{
TRUE if it looks like a remote reference
}
\description{
Check if String is a Remote Package Reference
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-or-set-repos.R
\name{rdd_set_repos}
\alias{rdd_set_repos}
\title{Set \code{rdocdump} Repository Options}
\usage{
rdd_set_repos(repos)
}
\arguments{
\item{repos}{A character vector of repository URLs.}
}
\value{
Invisibly returns the new repository URLs.
}
\description{
This function sets the package repository URLs used by \code{rdocdump} when fetching package sources. May be useful for setting custom repositories or mirrors. This does not affect the repositories used by \code{install.packages()} in your current R session and/or project.
}
\examples{
# Set rdocdump repository options
rdd_set_repos(c("CRAN" = "https://cloud.r-project.org"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/set_cache_path.R
\name{rdd_set_cache_path}
\alias{rdd_set_cache_path}
\title{Set \code{rdocdump} Cache Path in the Current R Session}
\usage{
rdd_set_cache_path(path)
}
\arguments{
\item{path}{A \code{character} string specifying the directory to be used as the cache path.}
}
\value{
Invisibly returns the new cache path.
}
\description{
This function sets the cache path used by \code{rdocdump} to store temporary files (downloaded tar.gz archives and/or extracted directories) for the current R session. The cache path is stored in the option \code{"rdocdump.cache_path"}, which can be checked with \code{getOption("rdocdump.cache_path")}. The path is created if it does not exist.
}
\examples{
# set cache directory for `rdocdump`
rdd_set_cache_path(paste0(tempdir(), "/rdocdump_cache"))
# default cache directory
unlink(getOption("rdocdump.cache_path"), recursive = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{get_remote_cache_dir}
\alias{get_remote_cache_dir}
\title{Get Cache Directory for Remote Package}
\usage{
get_remote_cache_dir(parsed, cache_path)
}
\arguments{
\item{parsed}{Parsed reference}

\item{cache_path}{Base cache path}
}
\value{
Path to cache directory
}
\description{
Get Cache Directory for Remote Package
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_code.R
\name{extract_code_installed}
\alias{extract_code_installed}
\title{Extract code from an installed package using its namespace.
This function retrieves all functions from the package namespace and deparses them to get their source code.}
\usage{
extract_code_installed(pkg_name)
}
\arguments{
\item{pkg_name}{The name of the installed package.}
}
\value{
A single string containing the source code of all functions in the package.
}
\description{
Extract code from an installed package using its namespace.
This function retrieves all functions from the package namespace and deparses them to get their source code.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_cleanup_files.R
\name{cleanup_files}
\alias{cleanup_files}
\title{Cleanup Temporary Files}
\usage{
cleanup_files(pkg_info, keep_files)
}
\arguments{
\item{pkg_info}{A list returned by \code{resolve_pkg_path()}, containing \code{tar_path} and \code{extracted_path}.}

\item{keep_files}{A \code{character} value controlling whether temporary files should be kept.
Possible values are:
\itemize{
\item \code{"none"}: Delete both the tar.gz archive and the extracted files (default).
\item \code{"tgz"}: Keep only the tar.gz archive.
\item \code{"extracted"}: Keep only the extracted files.
\item \code{"both"}: Keep both the tar.gz archive and the extracted files.
}}
}
\value{
Invisibly returns \code{NULL}. If there are any issues with file deletion, warnings are issued.
}
\description{
Clean up temporary package archive and extracted files according to a keep_files policy.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_code.R
\name{extract_code_source}
\alias{extract_code_source}
\title{Helper function to extract code from package source files.
This function reads all \code{.R} files in the \code{R} directory and optionally includes files from the \code{tests} directory.
It can also exclude roxygen2 documentation lines.}
\usage{
extract_code_source(pkg_path, include_tests = FALSE, include_roxygen = FALSE)
}
\arguments{
\item{pkg_path}{Path to the package source directory.}

\item{include_tests}{\code{logical}. If \code{TRUE}, for non-installed packages, the function will also include R source code from the \code{tests} directory. Defaults to \code{FALSE}.}

\item{include_roxygen}{\code{logical}. If \code{TRUE}, roxygen2 documentation lines (lines starting with "#'") from R files will be included in the output. Defaults to \code{FALSE}.}
}
\value{
A single string containing the source code from the package's R files.
}
\description{
Helper function to extract code from package source files.
This function reads all \code{.R} files in the \code{R} directory and optionally includes files from the \code{tests} directory.
It can also exclude roxygen2 documentation lines.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_pkg_path.R
\name{resolve_pkg_path}
\alias{resolve_pkg_path}
\title{Resolve the path to a package directory or tarball}
\usage{
resolve_pkg_path(
  pkg,
  cache_path = NULL,
  force_fetch = FALSE,
  version = NULL,
  repos = getOption("rdocdump.repos", getOption("repos"))
)
}
\arguments{
\item{pkg}{A \code{character} string specifying the package. This can be:
\itemize{
\item an installed package name,
\item a full path to a package source directory,
\item a full path to a package archive file (tar.gz), or
\item a package name not installed (which will then be downloaded from CRAN).
}}

\item{cache_path}{A \code{character} string specifying the directory where kept temporary files will be stored.
By default, it uses the value of \code{getOption("rdocdump.cache_path")} which sets the cache directory to the temporary directory of the current R session.}

\item{force_fetch}{\code{logical}. If \code{TRUE}, the package source will be fetched from CRAN as a tar.gz archive even if the package is already installed locally. Default is \code{FALSE}, but when \code{version} is specified, it will be set to \code{TRUE}.}

\item{version}{Optional. A \code{character} string specifying the package version to fetch from CRAN. If not provided, the latest version will be used.}

\item{repos}{A \code{character} vector of repository URLs. By default, it uses the value of \code{getOption("rdocdump.repos")} which sets the repository URLs to the default R repositories and is itself set to \code{c("CRAN" = "https://cloud.r-project.org")} on package load to prevent accidental downloads of pre-built packages from Posit Package Manager and R Universe.}
}
\value{
A list containing:
\itemize{
\item \code{pkg_path}: Path to the package directory or tarball.
\item \code{extracted_path}: Path to the extracted package directory (if applicable).
\item \code{tar_path}: Path to the tarball if it was downloaded.
\item \code{is_installed}: Logical indicating if the package is installed.
}
}
\description{
This function resolves the path to a package directory or tarball, handling both installed packages and source packages from CRAN.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{parse_remote_ref}
\alias{parse_remote_ref}
\title{Parse Remote Reference String}
\usage{
parse_remote_ref(ref)
}
\arguments{
\item{ref}{Character string reference}
}
\value{
List with components: type, user, repo, ref, subdir
}
\description{
Supports formats:
\itemize{
\item "user/repo" -> GitHub shorthand
\item "github::user/repo" -> Explicit GitHub
\item "gitlab::user/repo" -> GitLab
\item "bitbucket::user/repo" -> Bitbucket
\item "user/repo@ref" -> With commit/branch/tag
\item "user/repo/subdir" -> With subdirectory
\item "user/repo/subdir@ref" -> Combined
\item "https://github.com/user/repo/tree/ref/subdir" -> Web URL
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_combine_rd.R
\name{combine_rd}
\alias{combine_rd}
\title{Combine Rd files into a single character vector.
This function reads the Rd files from a package source directory or an installed package and combines them into a single string.}
\usage{
combine_rd(pkg_path, is_installed = FALSE, pkg_name = NULL)
}
\arguments{
\item{pkg_path}{Path to the package source directory or the installed package.}

\item{is_installed}{Logical indicating whether the package is installed (\code{TRUE}) or a source package (\code{FALSE}).}

\item{pkg_name}{Optional package name if the package is installed.}
}
\value{
A single string containing the combined Rd documentation.
}
\description{
Combine Rd files into a single character vector.
This function reads the Rd files from a package source directory or an installed package and combines them into a single string.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_combine_vignettes.R
\name{combine_vignettes}
\alias{combine_vignettes}
\title{Helper function to combine package vignettes}
\usage{
combine_vignettes(pkg_path)
}
\arguments{
\item{pkg_path}{Path to the package source directory.}
}
\value{
A single string containing the combined vignettes from the package.
}
\description{
Helper function to combine package vignettes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{create_remote}
\alias{create_remote}
\title{Create Remote Object for remotes Package}
\usage{
create_remote(parsed)
}
\arguments{
\item{parsed}{Parsed reference from parse_remote_ref()}
}
\value{
Remote object suitable for remotes::remote_download()
}
\description{
Create Remote Object for remotes Package
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_code.R
\name{rdd_extract_code}
\alias{rdd_extract_code}
\title{Extract R Source Code from a Package}
\usage{
rdd_extract_code(
  pkg,
  file = NULL,
  include_tests = FALSE,
  include_roxygen = FALSE,
  force_fetch = FALSE,
  version = NULL,
  cache_path = getOption("rdocdump.cache_path"),
  keep_files = "none",
  repos = getOption("rdocdump.repos", getOption("repos"))
)
}
\arguments{
\item{pkg}{A \code{character} string specifying the package. This can be:
\itemize{
\item an installed package name,
\item a full path to a package source directory,
\item a full path to a package archive file (tar.gz), or
\item a package name not installed (which will then be downloaded from CRAN).
}}

\item{file}{Optional. Save path for the output text file. If set, the function will return the path to the file instead of the combined text. Defaults to \code{NULL}.}

\item{include_tests}{\code{logical}. If \code{TRUE}, for non-installed packages, the function will also include R source code from the \code{tests} directory. Defaults to \code{FALSE}.}

\item{include_roxygen}{\code{logical}. If \code{TRUE}, roxygen2 documentation lines (lines starting with "#'") from R files will be included in the output. Defaults to \code{FALSE}.}

\item{force_fetch}{\code{logical}. If \code{TRUE}, the package source will be fetched from CRAN even if the package is installed locally. Default is \code{FALSE}, but when \code{version} is specified, it will be set to \code{TRUE}.}

\item{version}{Optional. A \code{character} string specifying the package version to fetch from CRAN. If not provided, the latest version will be used.}

\item{cache_path}{A \code{character} string specifying the directory to use as a cache. Defaults to the value of \code{getOption("rdocdump.cache_path")}.}

\item{keep_files}{A \code{character} value controlling whether temporary files should be kept.
Possible values are:
\itemize{
\item \code{"none"}: Delete both the tar.gz archive and the extracted files (default).
\item \code{"tgz"}: Keep only the tar.gz archive.
\item \code{"extracted"}: Keep only the extracted files.
\item \code{"both"}: Keep both the tar.gz archive and the extracted files.
}}

\item{repos}{A \code{character} vector of repository URLs. By default, it uses the value of \code{getOption("rdocdump.repos")} which sets the repository URLs to the default R repositories and is itself set to \code{c("CRAN" = "https://cloud.r-project.org")} on package load to prevent accidental downloads of pre-built packages from Posit Package Manager and R Universe.}
}
\value{
A single string containing the combined R source code (and, optionally, roxygen2 documentation) from the package.
}
\description{
This function extracts the R source code from a package. For installed packages, it retrieves the package namespace and deparses all functions found in the package. For package source directories or archives (non-installed packages), it reads all \code{.R} files from the \code{R} directory and, optionally, from the \code{tests} directory. Optionally, it can include roxygen2 documentation from these files.
}
\examples{
# Extract only R source code (excluding roxygen2 documentation) from an installed package.
code <- rdd_extract_code("splines")
cat(substr(code, 1, 1000))

# Extract R source code including roxygen2 documentation from a package source directory.
\donttest{
# set cache directory for `rdocdump`
rdd_set_cache_path(paste0(tempdir(), "/rdocdump_cache"))

local({
code_with_roxygen <- rdd_extract_code(
"ini",
include_roxygen = TRUE,
force_fetch = TRUE,
repos = c("CRAN" = "https://cran.r-project.org")
)
cat(substr(code_with_roxygen, 1, 1000))
})

# Extract R source code from a package source directory,
# including test files but excluding roxygen2 docs.
local({
code_with_tests <- rdd_extract_code(
"ini",
include_roxygen = TRUE,
include_tests = TRUE,
force_fetch = TRUE,
repos = c("CRAN" = "https://cran.r-project.org")
)
cat(substr(code_with_tests, 1, 1000))
})
# clean cache directory
unlink(getOption("rdocdump.cache_path"), recursive = TRUE, force = TRUE)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/to_txt.R
\name{rdd_to_txt}
\alias{rdd_to_txt}
\title{Dump Package Source, Documentationm and Vignettes into Plain Text}
\usage{
rdd_to_txt(
  pkg,
  file = NULL,
  content = "all",
  force_fetch = FALSE,
  version = NULL,
  keep_files = "none",
  cache_path = getOption("rdocdump.cache_path"),
  repos = getOption("rdocdump.repos", getOption("repos"))
)
}
\arguments{
\item{pkg}{A \code{character} string specifying the package. This can be:
\itemize{
\item an installed package name,
\item a full path to a package source directory,
\item a full path to a package archive file (tar.gz), or
\item a package name not installed (which will then be downloaded from CRAN).
}}

\item{file}{Optional. Save path for the output text file. If set, the function will return the path to the file instead of the combined text. Defaults to \code{NULL}.}

\item{content}{A character vector specifying which components to include in the output.
Possible values are:
\itemize{
\item \code{"all"}: Include Rd documentation, vignettes, and R source code (default).
\item \code{"docs"}: Include only the Rd documentation.
\item \code{"vignettes"}: Include only the vignettes.
\item \code{"code"}: Include only the R source code. When extracting code for non-installed packages, the function will not include roxygen2 documentation, as the documentation can be imported from the Rd files. If you want to extract the R source code with the roxygen2 documentation, use \code{\link{rdd_extract_code}} and set \code{include_roxygen} to \code{TRUE}.
}
You can specify multiple options (e.g., \code{c("docs", "code")} to include both documentation and source code).}

\item{force_fetch}{\code{logical}. If \code{TRUE}, the package source will be fetched from CRAN as a tar.gz archive even if the package is already installed locally. Default is \code{FALSE}, but when \code{version} is specified, it will be set to \code{TRUE}.}

\item{version}{Optional. A \code{character} string specifying the package version to fetch from CRAN. If not provided, the latest version will be used.}

\item{keep_files}{A \code{character} value controlling whether temporary files should be kept.
Possible values are:
\itemize{
\item \code{"none"}: Delete both the tar.gz archive and the extracted files (default).
\item \code{"tgz"}: Keep only the tar.gz archive.
\item \code{"extracted"}: Keep only the extracted files.
\item \code{"both"}: Keep both the tar.gz archive and the extracted files.
}}

\item{cache_path}{A \code{character} string specifying the directory where kept temporary files will be stored.
By default, it uses the value of \code{getOption("rdocdump.cache_path")} which sets the cache directory to the temporary directory of the current R session.}

\item{repos}{A \code{character} vector of repository URLs. By default, it uses the value of \code{getOption("rdocdump.repos")} which sets the repository URLs to the default R repositories and is itself set to \code{c("CRAN" = "https://cloud.r-project.org")} on package load to prevent accidental downloads of pre-built packages from Posit Package Manager and R Universe.}
}
\value{
A single string containing the combined package documentation, vignettes, and/or code as specified by the \code{content} argument.
If the \code{file} argument is set, returns the path to the file.
}
\description{
This function produces a single text output for an R package by processing its documentation (Rd files from the package source or the documentation from already installed packages), vignettes, and/or R source code.
}
\examples{
# Extract documentation for built-in `stats` package (both docs and vignettes).
docs <- rdd_to_txt("splines")
cat(substr(docs, 1, 500))

\donttest{
# set cache directory for `rdocdump`
rdd_set_cache_path(paste0(tempdir(), "/rdocdump_cache"))

# Extract only documentation for rJavaEnv by downloading its source from CRAN
docs <- rdd_to_txt(
  "rJavaEnv",
  force_fetch = TRUE,
  content = "docs",
  repos = c("CRAN" = "https://cran.r-project.org")
)
lines <- unlist(strsplit(docs, "\n"))
# Print the first 3 lines
cat(head(lines, 3), sep = "\n")
# Print the last 3 lines
cat(tail(lines, 3), sep = "\n")

# clean cache directory
unlink(getOption("rdocdump.cache_path"), recursive = TRUE, force = TRUE)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{resolve_remote_pkg}
\alias{resolve_remote_pkg}
\title{Resolve Remote Package References (GitHub, GitLab, Bitbucket)}
\usage{
resolve_remote_pkg(pkg_ref, cache_path = NULL)
}
\arguments{
\item{pkg_ref}{A character string specifying the remote package reference.
Supports formats like:
\itemize{
\item \code{"user/repo"} - GitHub shorthand (default)
\item \code{"github::user/repo"} - Explicit GitHub
\item \code{"gitlab::user/repo"} - GitLab
\item \code{"bitbucket::user/repo"} - Bitbucket
\item \code{"user/repo@ref"} - Specific commit, branch, or tag
\item \code{"user/repo/subdir"} - Package in subdirectory
}}

\item{cache_path}{Optional path to cache directory. If NULL, uses temp directory.}
}
\value{
A list containing:
\itemize{
\item \code{pkg_path}: Path to the package directory
\item \code{extracted_path}: Path to the extracted bundle
\item \code{tar_path}: Path to the downloaded tarball
\item \code{is_installed}: FALSE (always FALSE for remote packages)
\item \code{remote_info}: Parsed remote reference information
}
}
\description{
Downloads package source from remote repositories (GitHub, GitLab, Bitbucket)
without installing the package. Uses the \code{remotes} package for downloading.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-or-set-repos.R
\name{rdd_get_repos}
\alias{rdd_get_repos}
\title{Get Current \code{rdocdump} Repository Options}
\usage{
rdd_get_repos()
}
\value{
A character vector of repository URLs.
}
\description{
This function returns the current repository URLs used by \code{rdocdump}. The default is set to the CRAN repository at "https://cloud.r-project.org". This does not affect the repositories used by \code{install.packages()} in your current R session and/or project. To set repository options, use \code{\link{rdd_set_repos}}.
}
\examples{
# Get current rdocdump repository options
rdd_get_repos()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{find_pkg_dir}
\alias{find_pkg_dir}
\title{Find Package Directory Within Extracted Bundle}
\usage{
find_pkg_dir(extract_dir, subdir = NULL)
}
\arguments{
\item{extract_dir}{Directory where bundle was extracted}

\item{subdir}{Optional subdirectory path}
}
\value{
Path to package directory
}
\description{
Find Package Directory Within Extracted Bundle
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util_resolve_remote.R
\name{parse_remote_url}
\alias{parse_remote_url}
\title{Parse GitHub or GitLab Web URL}
\usage{
parse_remote_url(url)
}
\arguments{
\item{url}{The full URL string}
}
\value{
List with components: type, user, repo, ref, subdir
}
\description{
Parse GitHub or GitLab Web URL
}
\keyword{internal}
